c
code for plotlib
      subroutine plotlib
c--dummy routine to identify the module
c
      return
      end
c
code for gstor                                                                  
      subroutine gstor(gd,l1m1)                                                 
c  fornisce nella matrice gd(3,3) la metrica memorizzata                        
c  in store dall'indirizzo l1m1                                                 
      common /xdata/store(800000)
      dimension gd(3,3)                                                         
      l=l1m1                                                                    
      do 5 i=1,3                                                                
      do 5 j=1,3                                                                
      gd(i,j)=store(l)                                                          
      l=l+1                                                                     
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for storo                                                                  
      subroutine storo(xo,yo,zo,lj)                                             
c  xo, yo, zo forniscono le coordinate dell'atomo                               
c  m5-esimo                                                                     
      common /xdata/store(800000)
      xo=store(lj+2)                                                            
      yo=store(lj+3)                                                            
      zo=store(lj+4)                                                            
      return                                                                    
      end                                                                       
c                                                                               
code for ostor                                                                  
      subroutine ostor(xn,yn,zn,lj)                                             
c  ripristina con xn, yn, zn le coordinate dell'atomo                           
c  m5-esimo                                                                     
      common /xdata/store(800000)
      store(lj+2)=xn                                                            
      store(lj+3)=yn                                                            
      store(lj+4)=zn                                                            
      return                                                                    
      end                                                                       
c                                                                               
code for bstor                                                                  
      subroutine bstor(b,lj)                                                    
c  fornisce in b la matrice dell'ellissoide m5-esimo                            
      common/xdata/store(800000)
      dimension b(3,3)                                                          
      do 20 i=1,3                                                               
      do 20 j=1,3                                                               
      b(i,j)=0.                                                                 
   20 continue                                                                  
      b(1,1)=store(lj+5)                                                        
      b(1,2)=store(lj+6)/2.
      b(1,3)=store(lj+7)/2.
      b(2,2)=store(lj+8)
      b(2,3)=store(lj+9)/2.
      b(3,3)=store(lj+10)
      b(2,1)=b(1,2)
      b(3,1)=b(1,3)
      b(3,2)=b(2,3)
      return
      end
c
code for storb
      subroutine storb(b,lj)
c--ripristina in store la matrice b(3,3) che rappresenta
c  l'ellissoide
      common/xdata/store(800000)
      dimension b(3,3)
      store(lj+5)=b(1,1)
      store(lj+6)=b(1,2)*2.
      store(lj+7)=b(1,3)*2.
      store(lj+8)=b(2,2)
      store(lj+9)=b(2,3)*2.
      store(lj+10)=b(3,3)
      return                                                                    
      end                                                                       
c                                                                               
code for mtrc                                                                   
      subroutine mtrc(ncs,u)                                                    
c-- ncs=0:   u is the matrix having u(i,i)=1 and u(i,j)=0                       
c-- ncs=1:   u is the matrix having u(i,i)=-1 and u(i,j)=0                      
      dimension u(3,3)                                                          
      do 25 i=1,3                                                               
      do 25 j=1,3                                                               
      if(i.eq.j) go to 5                                                        
      u(i,j)=0.                                                                 
      go to 20                                                                  
    5 if(ncs.eq.0) go to 10                                                     
      if(ncs.eq.1) go to 15                                                     
   10 u(i,j)=1.                                                                 
      go to 20                                                                  
   15 u(i,j)=-1.                                                                
   20 continue                                                                  
   25 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for storn                                                                  
      subroutine storn(lj,sn)                                                   
c**sn fornisce il serial number dell'atomo lj-mo
      common/xdata/store(800000)
      sn=store(lj+1)                                                            
      return                                                                    
      end                                                                       
c                                                                               
code for nstor                                                                  
      subroutine nstor(lj,snn)                                                  
c**ripristina con nsn il serial number dell'atomo lj-mo
      common/xdata/store(800000)
      store(lj+1)=snn                                                           
      return                                                                    
      end                                                                       
c                                                                               
code for seq                                                                    
      subroutine seq(i,j,k)                                                     
      j=mod(i,3)+1                                                              
      k=mod(i+1,3)+1                                                            
      end                                                                       
c                                                                               
code for orcor                                                                  
      subroutine orcor(xo,yo,zo,c,xn,yn,zn)                                     
c**fornisce le coordinate atomiche ortogonalizzate
      dimension c(3,3)                                                          
      xn=c(1,1)*xo+c(1,2)*yo+c(1,3)*zo                                          
      yn=c(2,1)*xo+c(2,2)*yo+c(2,3)*zo                                          
      zn=c(3,1)*xo+c(3,2)*yo+c(3,3)*zo                                          
      return                                                                    
      end                                                                       
c                                                                               
code for mxmxm                                                                  
      subroutine mxmxm(c1,c2)                                                   
c**prodotto righexcolonne
      dimension c1(3,3),c2(3,3),c3(3,3)                                         
      do 5 i=1,3                                                                
      do 5 j=1,3                                                                
      c3(i,j)=0.0                                                               
      do 5 k=1,3                                                                
      c3(i,j)=c3(i,j)+c1(i,k)*c2(k,j)                                           
    5 continue                                                                  
      do 10 i=1,3                                                               
      do 10 j=1,3                                                               
      c2(i,j)=0.0                                                               
      do 10 k=1,3                                                               
      c2(i,j)=c2(i,j)+c3(i,k)*c1(j,k)                                           
   10 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for prodm                                                                  
      subroutine prodm(a,b,prod)                                                
c-- rows x coloumns                                                             
      dimension a(3,3),b(3,3),prod(3,3)                                         
      do 5 i=1,3                                                                
      do 5 j=1,3                                                                
      prod(i,j)=0.                                                              
    5 continue                                                                  
      do 20 k=1,3                                                               
      do 15 i=1,3                                                               
      do 10 j=1,3                                                               
      prod(k,i)=prod(k,i)+a(k,j)*b(j,i)                                         
   10 continue                                                                  
   15 continue                                                                  
   20 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for prods                                                                  
      subroutine prods(c,va,vb,vavb)                                            
c-- scalar product                                                              
      dimension c(3,3),va(3),vb(3)                                              
      vavb=0.                                                                   
      do 5 i=1,3                                                                
      do 5 j=1,3                                                                
      vavb=vavb+va(i)*vb(j)*c(i,j)                                              
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for lngth                                                                  
      subroutine lngth(a,v1,v2,dist)                                            
c-- distance calculation                                                        
      dimension a(3,3),v1(3),v2(3),del(3)                                       
      do 5 i=1,3                                                                
      del(i)=v1(i)-v2(i)                                                        
    5 continue                                                                  
      call prods(a,del,del,dist)                                                
      dist=sqrt(dist)                                                           
      return                                                                    
      end                                                                       
c                                                                               
code for normer
      subroutine normer(vt,am,vtn)
c**normalizzazione di un vettore
      dimension vt(3),am(3,3),vtn(3)                                            
      vtvt=0.0                                                                  
      do 5 i=1,3                                                                
      do 5 j=1,3                                                                
      vtvt=vtvt+vt(i)*vt(j)*am(i,j)                                             
    5 continue                                                                  
      cost=sqrt(vtvt)                                                           
      do 10 i=1,3                                                               
      vtn(i)=vt(i)/cost                                                         
   10 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for prodv                                                                  
      subroutine prodv(dt,am,ar,v1,v2,vr3,v3)                                   
c**calcola il prodotto vettoriale
      dimension v1(3),v2(3),v3(3),am(3,3),ar(3,3),vr3(3)                        
      do 5 i=1,3                                                                
      call seq(i,j,k)                                                           
      vr3(i)=(v1(j)*v2(k)-v1(k)*v2(j))/dt                                       
    5 continue                                                                  
      call vrgv(vr3,ar,v3)                                                      
      return                                                                    
      end                                                                       
c                                                                               
code for vrgv                                                                   
      subroutine vrgv(ve,c,vu)                                                  
c**moltiplicazione di una matrice 3x3 ed un vettore a 3
c  componenti
      dimension ve(3),c(3,3),vu(3)                                              
      do 10 i=1,3                                                               
      vu(i)=0.0                                                                 
      do 5 j=1,3                                                                
      vu(i)=vu(i)+c(i,j)*ve(j)                                                  
    5 continue                                                                  
   10 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for trsp                                                                   
      subroutine trasp(c,ct)                                                    
c**matrice trasposta
      dimension c(3,3),ct(3,3)                                                  
      do 10 i=1,3                                                               
      do 5 j=1,3                                                                
      ct(i,j)=c(j,i)                                                            
    5 continue                                                                  
   10 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for lngto                                                                  
      subroutine lngto(x1,x2,dist)                                              
      dimension x1(3),x2(3)                                                     
      dist=(x2(1)-x1(1))**2+(x2(2)-x1(2))**2+(x2(3)-x1(3))**2                   
      dist=sqrt(dist)                                                           
      return                                                                    
      end                                                                       
c                                                                               
code for lngtp                                                                  
      subroutine lngtp(x1,x2,d)                                                 
      dimension x1(3),x2(3)                                                     
      d=(x2(1)-x1(1))**2+(x2(2)-x1(2))**2                                       
      d=sqrt(d)                                                                 
      return                                                                    
      end                                                                       
c                                                                               
code for  stor                                                                  
      subroutine stor(lj,v)                                                     
      common/xdata/store(800000)
      dimension v(3)                                                            
      v(1)=store(lj+2)                                                          
      v(2)=store(lj+3)                                                          
      v(3)=store(lj+4)                                                          
      return                                                                    
      end                                                                       
c                                                                               
code for stor2                                                                  
      subroutine stor2(lj,v)                                                    
      common/xdata/store(800000)
      dimension v(3)                                                            
      v(1)=store(lj)                                                            
      v(2)=store(lj+1)                                                          
      v(3)=0.                                                                   
      return                                                                    
      end                                                                       
c                                                                               
code for osto                                                                   
      subroutine osto(vn,lj)                                                    
      common/xdata/store(800000)
      dimension vn(3)                                                           
      store(lj+2)=vn(1)                                                         
      store(lj+3)=vn(2)                                                         
      store(lj+4)=vn(3)                                                         
      return                                                                    
      end                                                                       
c
code for ord
      subroutine ord(inte,nfli,ifus)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      int=inte
c-- ordinamento posti dispari
      do 15 j=1,int+1,2
      do 10 j1=j+2,int+3,2
      if(store(nfli+j).le.store(nfli+j1)) go to 5
      com1=store(nfli+j)
      store(nfli+j)=store(nfli+j1)
      store(nfli+j1)=com1
    5 continue
   10 continue
   15 continue
c-- ordinamento posti dispari
      do 35 j=2,int+2,2
      do 30 j1=j+2,int+4,2
      if(store(nfli+j).le.store(nfli+j1)) go to 25
      com1=store(nfli+j)
      store(nfli+j)=store(nfli+j1)
      store(nfli+j1)=com1
   25 continue
   30 continue
   35 continue
c-- fusione intervalli
      ifus=0
      j=2
   40 continue
      jf=int+2
   45 continue
      if(j-jf) 50,65,65
   50 continue
      if(store(nfli+j).lt.store(nfli+j+1)) go to 60
      do 55 j1=j,int+4
      store(nfli+j1)=store(nfli+j1+2)
   55 continue
      ifus=ifus+1
      int=int-2
      go to 40
   60 continue
      j=j+2
      go to 45
   65 continue
      return
      end
c                                                                               
code for anco                                                                   
      subroutine anco(va,vb,ac)                                                 
      common/xcost/zero,eps0,icost(198)
      dimension va(3),vb(3)                                                     
      dy=vb(2)-va(2)                                                            
      dx=vb(1)-va(1)                                                            
      if(abs(dx).le.zero) go to 5                                               
      ac=dy/dx                                                                  
      return                                                                    
    5 continue                                                                  
      ac=3000.                                                                  
      return                                                                    
      end                                                                       
c
code for ang2
      subroutine ang2(ac1,ac2,teta)
      common/xcons/pi,twopis,twopi,rtd,dtr
      common/xcost/zero,eps0,icost(198)
      zero=0.001
      acac=1+ac2*ac1
      tg=ac1-ac2
      if((abs(acac).lt.0.0001).and.(abs(tg).lt.0.0001))go to 5
      teta=atan2(tg,acac)
      if(teta.gt.0) return
      teta=pi-abs(teta)
      return
    5 continue
      return                                                                    
      end                                                                       
c                                                                               
code for change                                                                 
      subroutine change(v1,v2)                                                  
c-- copia il vettore v1 nel vettore v2 e viceversa                              
      dimension v1(3),v2(3),com(3)                                              
      do 5 i=1,3                                                                
      com(i)=v1(i)                                                              
      v1(i)=v2(i)                                                               
      v2(i)=com(i)                                                              
    5 continue                                                                  
      return                                                                    
      end                                                                       
c
code for lrp
      function lrp(ity,sn)                                                      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,icc,ia,ih                                           
     * ,numb(10),iplus, inus,ipoint                                             
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)          
      common/xtemp/itemp(80)                                                    
      dimension temp(1)                                                         
      equivalence(itemp,temp)                                                   
c--                                                                             
      common /xdata/ store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
c--                                                                             
      lrp=0                                                                     
      if(jrcx(itemp(1),n,id,4)) 25,5,25                                         
    5 continue                                                                  
      ity=itemp(1)                                                              
      j1=kredi(i)                                                               
      if(j1) 20,20,10                                                           
   10 continue                                                                  
      sn=float(j1)                                                              
      if(image(nc)-ie) 25,15,25                                                 
   15 continue                                                                  
      nc=nc+1                                                                   
      return                                                                    
   20 continue                                                                  
      lrp=1                                                                     
      return                                                                    
   25 continue                                                                  
      lrp=-1                                                                    
      return                                                                    
      end                                                                       
c                                                                               
code for cwrli
      subroutine cwrli(n,l,md)
c**write list
c n total number of atoms
c l location of the first atom
c md number of words per atom
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      m=l
      do 15 i=1,n
      mi=m
      if(store(m+nstep).le.0.)go to 10
      write(ncwu,5)istore(mi),(store(m+ll),ll=1,nstep)
    5 format(2x,a2,11x,11f10.5)
   10 m=m+md
   15 continue
      return
      end                                                                       
c                                                                               
code for ndat                                                                   
      function ndat(ity,at,n,l,md,lk)                                           
c**ricerca nella lista un atomo individuato mediante
c  il type ed il serial number
c n total number of atoms                                                       
c l location of the first atom                                                  
c md number of words for atom
c lk indirizzo dell'atomo individuato
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      ndat=0                                                                    
      m=l                                                                       
      do 15 i=1,n                                                               
      mi=m
      if(istore(mi)-ity)10,5,          10                                       
    5 if(store(m+1)-at)10,30,10                                                 
   10 m=m+md                                                                    
   15 continue                                                                  
      ndat=1                                                                    
      write(ncwu,20)                                                            
   20 format(1x,'atom required not in list')                                    
      write(ncwu,25)                                                            
   25 format(1x,'chemical type or serial number wrong')                         
      return                                                                    
   30 lk=m                                                                      
      return                                                                    
      end                                                                       
c                                                                               
code for crtyp
      subroutine crtyp(ity,n,l,md)                                              
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      icoun=0                                                                   
      m=l                                                                       
      do 20 i=1,n                                                               
      mi=m
      if(istat2.gt.1) then
       write(ncwu,40) istore(mi),ity,store(m+nstep)
   40  format(' atom label (istore(mi),ity) and code = ',2a2,f5.0)
      end if
      if(istore(mi)-ity)15,5,15                                                 
    5 if(store(m+nstep).ge.6.)go to 10                                          
      store(m+nstep)=store(m+nstep)+5                                           
      icoun=icoun+1                                                             
   10 continue                                                                  
   15 continue                                                                  
      m=m+md                                                                    
   20 continue                                                                  
      if(icoun.eq.0) go to 25                                                   
      return                                                                    
   25 continue                                                                  
      write(ncwu,30)                                                            
   30 format(1x,'type is wrong')                                                
      return                                                                    
      end                                                                       
c                                                                               
code for crat                                                                   
      subroutine crat(ity,at,n,l,md)                                            
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
c--
      na=ndat(ity,at,n,l,md,lk)                                                 
      if(na.eq.1)go to 10                                                       
      if(store(lk+nstep).ge.6.)go to 5                                          
      store(lk+nstep)=store(lk+nstep)+5                                         
    5 continue                                                                  
      mi=lk
   10 return                                                                    
      end                                                                       
c                                                                               
code for crsq                                                                   
      subroutine crsq(ity,a,ity1,b,n,l,md)                                      
c list 25 generation                                                            
c n total number of atoms                                                       
c l location of the first atom                                                  
c md number of words per atom                                                   
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      nb=ndat(ity,a,n,l,md,lb)                                                  
      if(nb.eq.1)go to 25                                                       
      ne=ndat(ity1,b,n,l,md,lf)                                                 
      if(ne.eq.1)go to 25                                                       
      m=l                                                                       
      do 20 i=1,n                                                               
      mi=m
      if((m.ge.lb).and.(m.le.lf))go to 5                                        
      go to 15                                                                  
    5 continue                                                                  
      if(store(m+nstep).ge.6.)go to 10                                          
      store(m+nstep)=store(m+nstep)+5                                           
   10 continue                                                                  
   15 continue                                                                  
      m=m+md                                                                    
   20 continue                                                                  
   25 return                                                                    
      end                                                                       
c                                                                               
code for crall                                                                  
      subroutine crall(n,l,md)                                                  
c--read all list 5-25                                                           
      common/workb/hl(12),ncom,nstep                                            
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m=l                                                                       
      do 10 i=1,n                                                               
      mdi=m
      if(store(m+nstep).ge.6)go to 5                                            
      store(m+nstep)=store(m+nstep)+5                                           
    5 continue                                                                  
      m=m+md                                                                    
   10 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for rsocc                                                                  
      subroutine rsocc(mark)                                                    
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 100 i=1,n25                                                            
      if(store(m25+11).ge.6) go to 10                                           
      go to 20                                                                  
   10 continue                                                                  
      store(m25+11)=store(m25+11)-mark                                          
   20 continue                                                                  
      m25=m25+md25                                                              
  100 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for outyp                                                                  
      subroutine outyp(ity)                                                     
c--il fattore di occupazione dell' atomo di specie
c--chimica ity viene posto a -100.
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      icoun=0                                                                   
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25
      if(istore(m25i)-ity)15,5,15                                               
    5 store(m25+nstep)=-100.                                                    
      icoun=icoun+1                                                             
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
      if(icoun.eq.0) go to 25                                                   
      return                                                                    
   25 continue                                                                  
      write(ncwu,30)                                                            
   30 format(1x,'wrong type')                                                   
      return                                                                    
      end                                                                       
c                                                                               
code for outat                                                                  
      subroutine outat(ity,at)                                                  
c--il fattore di occupazione dell'atomo di specie chimica ity
c--e numero sequenziale at viene posto a -100
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      na=ndat(ity,at,n25,l25,md25,lk)                                           
      if(na.eq.1) go to 10                                                      
      store(lk+nstep)=-100.                                                     
      m25i=lk                                                            
   10 return                                                                    
      end                                                                       
c                                                                               
code for outsq                                                                  
      subroutine outsq(ity,a,ity1,b)                                            
c--il fattore di occupazione della sequenza di atomi
c--compresi fra ity a e ity1 b viene posto a -100
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      nb=ndat(ity,a,n25,l25,md25,lb)                                            
      if(nb.eq.1) go to 25                                                      
      ne=ndat(ity1,b,n25,l25,md25,lf)                                           
      if(ne.eq.1) go to 25                                                      
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if((m25.ge.lb).and.(m25.le.lf)) go to 5                                   
      go to 15                                                                  
    5 continue                                                                  
      store(m25+nstep)=-100.                                                    
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
   25 return                                                                    
      end                                                                       
c                                                                               
code for intyp                                                                  
      subroutine intyp(ity)                                                     
c--il fattore di occupazione degli atomi di specie chimica
c--ity viene posto a 1
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      icoun=0                                                                   
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if(istore(m25i)-ity) 15,5,15                                              
    5 store(m25+nstep)=1.                                                       
      icoun=icoun+1                                                             
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
      if(icoun.eq.0) go to 25                                                   
      return                                                                    
   25 continue                                                                  
      write(ncwu,30)                                                            
   30 format(1x,'wrong type')                                                   
      return                                                                    
      end                                                                       
c                                                                               
code for inat                                                                   
      subroutine inat(ity,at)                                                   
c--il fattore di occupazione dell' atomo di specie chimica
c--ity e numero di sequenza at viene posto ad 1
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      na=ndat(ity,at,n25,l25,md25,lk)                                           
      if(na.eq.1) go to 15                                                      
      store(lk+nstep)=1.                                                        
      m25i=m25                                                           
   15 return                                                                    
      end                                                                       
c                                                                               
code for insq                                                                   
      subroutine insq(ity,a,ity1,b)                                             
c--il fattore di occupazione degli atomi compresi fra
c--l' atomo ity1 a e l'atomo ity2 b viene posto ad 1
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      nb=ndat(ity,a,n25,l25,md25,lb)                                            
      if(nb.eq.1) go to 25                                                      
      ne=ndat(ity1,b,n25,l25,md25,lf)                                           
      if(ne.eq.1) go to 25                                                      
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if((m25.ge.lb).and.(m25.le.lf)) go to 5                                   
      go to 15                                                                  
    5 store(m25+nstep)=1.                                                       
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue
   25 return
      end
c                                                                               
code for botyp                                                                  
      subroutine botyp(ity,iflag)                                               
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      icoun=0                                                                   
      m25=l25                                                                   
      do 30 i=1,n25                                                             
      m25i=m25                                                           
      if(istore(m25i)-ity) 25,5,25                                              
    5 if((store(m25+nstep).lt.0).or.(store(m25+nstep).gt.1))                    
     *go to 25                                                                  
      if(iflag-2) 45,15, 10                                                     
   10 continue                                                                  
      if(iflag-4) 45,20, 45                                                     
   15 continue                                                                  
      store(m25+nstep)=store(m25+nstep)+2                                       
      icoun=icoun+1                                                             
      go to 25                                                                  
   20 continue                                                                  
      store(m25+nstep)=store(m25+nstep)+4                                       
      icoun=icoun+1                                                             
   25 continue                                                                  
      m25=m25+md25                                                              
   30 continue                                                                  
      if(icoun.eq.0) go to 35                                                   
      return                                                                    
   35 continue                                                                  
      write(ncwu,40)                                                            
   40 format(1x,'wrong type')                                                   
   45 return                                                                    
      end                                                                       
c                                                                               
code for boat                                                                   
      subroutine boat(ity,at,iflag)                                             
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      na=ndat(ity,at,n25,l25,md25,lk)                                           
      if(na.eq.1) go to 20                                                      
      if((store(lk+nstep).lt.0).or.(store(lk+nstep).gt.1)) go to 25             
      if(iflag-2) 20,10, 5                                                      
    5 continue                                                                  
      if(iflag-4) 20,15, 20                                                     
   10 continue                                                                  
      store(lk+nstep)=store(lk+nstep)+2                                         
      go to 20                                                                  
   15 continue                                                                  
      store(lk+nstep)=store(lk+nstep)+4                                         
   20 continue                                                                  
   25 continue                                                                  
      m25i=lk                                                            
      return                                                                    
      end                                                                       
c                                                                               
code for boall                                                                  
      subroutine boall                                                          
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 15 i=1,n25                                                             
      m25i=m25                                                           
      if((store(m25+nstep).ge.0).and.(store(m25+nstep).le.1))                   
     *go to 5                                                                   
      go to 10                                                                  
    5 continue                                                                  
      store(m25+nstep)=store(m25+nstep)+2                                       
   10 continue                                                                  
      m25=m25+md25                                                              
   15 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for mrot                                                                   
      subroutine mrot(ve,fi,rm)                                                 
c**costruisce la matrice di rotazione intorno al vettore ur
      dimension ve(3),rm(3,3),ven(3),um(3,3)                                    
      ncs=0                                                                     
      call mtrc(ncs,um)                                                         
      call normer(ve,um,ven)
      do 5 i=1,3                                                                
      call seq(i,j,k)                                                           
      rm(i,i)=ven(i)*ven(i)*(1-cos(fi))+cos(fi)                                 
      rm(i,j)=ven(i)*ven(j)*(1-cos(fi))-ven(k)*sin(fi)                          
      rm(i,k)=ven(i)*ven(k)*(1-cos(fi))+ven(j)*sin(fi)                          
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for focc                                                                   
      subroutine focc(ity,mark)                                                 
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if(istore(m25i)-ity) 15,5,15                                              
    5 continue                                                                  
      store(m25+nstep)=store(m25+nstep)+mark                                    
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for exbnd
      subroutine exbnd(ity,at,lim2)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      na=ndat(ity,at,n25,l25,md25,la)
      if(na.eq.1) go to 25
      m25=l25
      do 20 i=1,n25
      if(m25-la) 15,5,15
    5 continue
      store(nfl)=i
c      write(ncwu,758) i
c  758 format(1x,'i=',i5)
      nfl=nfl+1
      lim2=nfl
      return
   15 continue
      m25=m25+md25
   20 continue
   25 continue
      return                                                                    
      end                                                                       
c
code for bond
      subroutine bond(nflag)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep,icomb(12)
      common/lst25/l25,m25,md25,n25
      common/xcom/epst,epsa,ico(92),rm,p,bomax,lim1,lim2,
     *dis(2),skdk,zmax
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      dimension x1(3),x2(3)
      bomax=-1000000.
      dmin=dis(1)
      dmax=dis(2)
      dmin=dmin*skdk
      dmax=dmax*skdk
      lim1=nfl
      m25=l25
      lm25=m25
      do 65 i=1,n25
      m25i=m25
      if((store(m25+nstep).ge.2).and.(store(m25+nstep).le.3)) go to 5
      go to 60
    5 continue
      call stor(m25,x1)
      do 55 ii=1,n25
      if(nflag) 10,10,  15
   10 continue
      if(i-ii)20,50,50
   15 continue
      if(i-ii) 20,50,20
   20 continue
      lj=lm25+md25*(ii-1)
      if(nflag)25,25,30
   25 continue
      if((store(lj+nstep).ge.2).and.(store(lj+nstep).le.3))
     *go to 35
      go to 50
   30 continue
      if((store(lj+nstep).ge.4).and.(store(lj+nstep).le.5))
     *go to 35
      go to 50
   35 continue
      call stor(lj,x2)
      call lngto(x1,x2,dist)
      if((dist.ge.dmin).and.(dist.le.dmax)) go to 40
      go to 50
   40 continue
      if(dist.gt.bomax) bomax=dist
      if((nfl+2)-lfl) 45,100,100
   45 continue
      store(nfl)=i
      store(nfl+1)=ii
      nfl=nfl+2
   50 continue
   55 continue
   60 continue
      m25=m25+md25
   65 continue
      lim2=nfl
      if(istat2-1) 1,1,2
    2 continue
      write(ncwu,70)(store(i),i=lim1,lim2-1)
   70 format(1x,10f10.5)
    1 continue
      m25=l25
      do 95 i=1,n25
      if((store(m25+nstep).ge.2).and.(store(m25+nstep).le.3)) go to 75
      go to 80
   75 continue
      store(m25+nstep)=store(m25+nstep)-2.
   80 continue
      if((store(m25+nstep).ge.4).and.(store(m25+nstep).le.5)) go to 85
      go to 90
   85 continue
      store(m25+nstep)=store(m25+nstep)-4.
   90 continue
      m25=m25+md25
   95 continue
      return
  100 continue
      write(ncwu,105)
  105 format(1x,'no moore room in store!!!')
      return
      end
c
code for solv2
      subroutine solv2(a,b,c,x1,x2)
c--solution of a second degree equation :a*x**2+b*x+c=0
c--x1,x2:solutions
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      real*8 a,b,c
      delta=b**2-4*a*c
      if(delta) 1,2,3
    1 continue
      return
    2 continue
      x1=-b/(2*a)
      x2=x1
      return
    3 continue
      x1=(-b-sqrt(delta))/(2*a)
      x2=(-b+sqrt(delta))/(2*a)
      return
      end
c
code for s2rad8
      subroutine s2rad8(a,b,c,x1,x2)
c--solution of a second degree equation :a*x**2+b*x+c=0
c--x1,x2:solutions
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      real*8 a,b,c
      delta=b**2-4*a*c
      if(delta) 1,2,3
    1 continue
      return
    2 continue
      x1=-b/(2*a)
      x2=x1
      return
    3 continue
      x1=(-b-sqrt(delta))/(2*a)
      x2=(-b+sqrt(delta))/(2*a)
      return
      end
c
code for focc1
      subroutine focc1(ity,sn,mark)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/workb/hl(12),ncom,nstep                                            
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if(istore(m25i)-ity) 15,5,15                                              
    5 continue                                                                  
      if(store(m25+1)-sn) 15,16,15                                              
   16 continue                                                                  
      store(m25+nstep)=store(m25+nstep)+mark                                    
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for ordvet                                                                 
      subroutine ordvet(inum,icoun,v,jfus)                                      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension v(100)                                                          
      do 100 i=1,icoun                                                          
      if(v(i).lt.0) v(i)=0.                                                     
      if(v(i).gt.1) v(i)=1.                                                     
  100 continue                                                                  
      if(istat2-1) 6001,6001,6002                                               
 6002 write(ncwu,101) (v(i),i=1,icoun)                                          
  101 format(1x,'v=',10f10.5)                                                   
 6001 continue                                                                  
c-- ordinamento posti pari                                                      
      do 10 i=2,icoun-2,2                                                       
      do 15 i1=i+2,icoun,2                                                      
      if(v(i).le.v(i1)) go to 5                                                 
      com1=v(i)                                                                 
      v(i)=v(i1)                                                                
      v(i1)=com1                                                                
    5 continue                                                                  
   15 continue                                                                  
   10 continue                                                                  
      if(istat2-1) 7001,7001,7002                                               
 7002 write(ncwu,1) (v(i),i=1,icoun)                                            
    1 format(1x,'v-',10f10.5)                                                   
 7001 continue                                                                  
c-- ordinamento posti dispari                                                   
      do 20 i=1,icoun-3,2                                                       
      do 25 i1=i+2,icoun-1,2                                                    
      if(v(i).le.v(i1)) go to 70                                                
      com1=v(i)                                                                 
      v(i)=v(i1)                                                                
      v(i1)=com1                                                                
   70 continue                                                                  
   25 continue                                                                  
   20 continue                                                                  
c-------------                                                                  
      if(istat2-1) 8001,8001,8002                                               
 8002 write(ncwu,1) (v(i),i=1,icoun)                                            
 8001 continue                                                                  
c-- fusione di intervalli                                                       
      jfus=0.                                                                   
      j=2                                                                       
   40 continue                                                                  
      jf=inum+2                                                                 
   45 continue                                                                  
      if(j-jf) 50,50,65                                                         
   50 continue                                                                  
      if(v(j).lt.v(j+1)) go to 60                                               
      do 55 j1=j,inum+4                                                         
      v(j1)=v(j1+2)                                                             
   55 continue                                                                  
      jfus=jfus+1                                                               
      inum=inum-2                                                               
      icoun=icoun-2                                                             
      go to 40                                                                  
   60 continue                                                                  
      j=j+2                                                                     
      go to 45                                                                  
   65 continue                                                                  
      return                                                                    
      end
c
code for ellint
      subroutine ellint(va,vb,ea,eb,ndim,tet,im,
     *an,bn,cn,dn,en,fn)
      real*8 c1,c2,c3
c-----real*8 ea,eb
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      dimension va(3),vb(3),teta(10),xv(10),yv(10),
     *ea(2,2),eb(2,2),tet(10)
      ndim=0
      do 31 i=1,10
      teta(i)=0.
   31 continue
      a=ea(1,1)
      b=2.*ea(1,2)
      c=ea(2,2)
      d=eb(1,1)
      e=2.*eb(1,2)
      f=eb(2,2)
      h=vb(1)-va(1)
      s=vb(2)-va(2)
      call dtrasf(d,e,f,h,s,an,bn,cn,dn,en,fn)
      g=d*h*h+e*h*s+f*s*s-1
      if((h.eq.0).and.(s.eq.0)) go to 400
      a1=4*h*h*d*d+e*e*s*s+4*h*s*e*d
      b1=e*e*h*h+4*s*s*f*f+4*h*s*e*f
      c1=2*(2*h*h*e*d+4*h*s*d*f+e*e*h*s+2*e*s*s*f)
      a5=b1*c
      b5=b*b1+c*c1
      c5=a1*c+a*b1+b*c1
      d5=a*c1+a1*b
      e5=a*a1
      a2=2*c*f*g
      b2=2*c*e*g+2*b*f*g
      c2=2*c*g*d+2*b*e*g+2*a*f*g
      d2=2*b*g*d+2*a*e*g
      e2=2*a*g*d
      a3=f*f
      b3=2*e*f
      c3=e*e+2*d*f
      d3=2*e*d
      e3=d*d
      a4=c*c*g*g
      b4=2*b*c*g*g
      c4=b*b*g*g+2*a*c*g*g
      d4=2*a*b*g*g
      e4=a*a*g*g
      a5=b1*c
      b5=b*b1+c*c1
      c5=a1*c+a*b1+b*c1
      d5=a*c1+a1*b
      e5=a*a1
      a6=a5-a4-a3-a2
      b6=b5-b4-b3-b2
      c6=c5-c4-c3-c2
      d6=d5-d4-d3-d2
      e6=e5-e4-e3-e2
c      write(ncwu,*)'1) a6,b6,c6,d6,e6,q1,q2,q3,q4,im',
c     1 a6,b6,c6,d6,e6,q1,q2,q3,q4,im
      call solv4(a6,b6,c6,d6,e6,q1,q2,q3,q4,im)
c      write(ncwu,*)'2) a6,b6,c6,d6,e6,q1,q2,q3,q4,im',
c     1 a6,b6,c6,d6,e6,q1,q2,q3,q4,im
      if(im.eq.4) return
      if(im) 91,91,92
   91 ndim=4
      go to 93
   92 ndim=2
   93 continue
      cost1=sqrt(a+b*q1+c*q1*q1)
      cost2=sqrt(a+b*q2+c*q2*q2)
      x11=1/cost1
      x12=-1/cost1
      y11=q1*x11
      y12=q1*x12
      call sost(x11,x12,y11,y12,a,b,c,
     *an,bn,cn,dn,en,fn,x1,y1)
      x21=1/cost2
      x22=-1/cost2
      y21=q2*x21
      y22=q2*x22
      call sost(x21,x22,y21,y22,a,b,c,
     *an,bn,cn,dn,en,fn,x2,y2)
      xv(1)=x1
      xv(2)=x2
      yv(1)=y1
      yv(2)=y2
      if(im.eq.1) go to 300
      cost3=sqrt(a+b*q3+c*q3*q3)
      cost4=sqrt(a+b*q4+c*q4*q4)
      x31=1/cost3
      x32=-1/cost3
      y31=q3*x31
      y32=q3*x32
      call sost(x31,x32,y31,y32,a,b,c,
     *an,bn,cn,dn,en,fn,x3,y3)
      x41=1/cost4
      x42=-1/cost4
      y41=q4*x41
      y42=q4*x42
      call sost(x41,x42,y41,y42,a,b,c,
     *an,bn,cn,dn,en,fn,x4,y4)
      xv(3)=x3
      xv(4)=x4
      yv(3)=y3
      yv(4)=y4
      if(im.eq.1) go to 300
      go to 410
  400 continue
      c1=c*g+f
      c2=e+b*g
      c3=d+a*g
      call solv2(c1,c2,c3,q1,q2)
      cost1=sqrt(a+b*q1+c*q1*q1)
      cost2=sqrt(a+b*q2+c*q2*q2)
      xv(1)=1/cost1
      xv(2)=-1/cost1
      xv(3)=1/cost2
      xv(4)=-1/cost2
      yv(1)=q1*xv(1)
      yv(2)=q1*xv(2)
      yv(3)=q2*xv(3)
      yv(4)=q2*xv(4)
  410 continue
      ndim=4
      do 207 i=1,ndim
      if((abs(yv(i)).lt.0.0001).and.(abs(xv(i)).lt.0.0001))go to 209
      teta(i)=atan2(yv(i),xv(i))
      if(teta(i).lt.0) teta(i)=teta(i)+twopi
      go to 208
  209 continue
      if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in ellint ',
     * 'atan2(yv(i),xv(i))!!',/)
      teta(i)=0.
  208 continue
  207 continue
      call ordn(teta,xv,yv,ndim)
      call osc(teta,xv,yv,ndim,a,b,c,d,e,f,jf,jl)
      if(jf.eq.1) go to 95
      if(jf.eq.2) go to 96
      go to 710
   95 tet(1)=teta(2)
      tet(2)=teta(3)
      tet(3)=teta(4)
      tet(4)=teta(1)
      go to 700                                                                 
   96 tet(1)=teta(1)                                                            
      tet(2)=teta(2)                                                            
      tet(3)=teta(3)                                                            
      tet(4)=teta(4)                                                            
      go to 700                                                                 
  300 continue                                                                  
      u1=h                                                                      
      u2=s                                                                      
      call arc1(x1,y1,x2,y2,u1,u2,teta1,teta2)                                  
      tet(1)=teta2                                                              
      tet(2)=teta1                                                              
      ndim=2                                                                    
      go to 710                                                                 
  700 continue                                                                  
  710 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for ordn                                                                   
      subroutine ordn(teta,xv,yv,ndim)                                          
c--ordina i vettori teta xv yv
c--teta: vettore contenente gli angoli calcolati
c--xv:vettore contente le ascisse dei punti
c--yv:vettore contenente le oridnate dei punti
c--ndim: dimensione del vettore teta ordinato
      dimension teta(10),xv(10),yv(10)                                          
      do 10 i=1,ndim-1                                                          
      do 15 j=i+1,ndim                                                          
      if(teta(i)-teta(j)) 1,1,2                                                 
    2 continue                                                                  
      com1=teta(i)                                                              
      teta(i)=teta(j)                                                           
      teta(j)=com1                                                              
      com2=xv(i)                                                                
      xv(i)=xv(j)                                                               
      xv(j)=com2                                                                
      com3=yv(i)                                                                
      yv(i)=yv(j)                                                               
      yv(j)=com3                                                                
    1 continue                                                                  
   15 continue                                                                  
   10 continue                                                                  
c     teta(ndim+1)=teta(1)                                                      
c     ndim=ndim+1                                                               
      return                                                                    
      end                                                                       
c                                                                               
code for osc                                                                    
      subroutine osc(teta,xv,yv,ndim,a,b,c,d,e,f,jf,jl)                         
c- decide gli archi di ellisse da disegnare                                     
c--jf=1=> si disegna a partire da teta(1)
c--jf=2=> si disegna a partire da teta(2)
      dimension teta(10),xv(10),yv(10),u(3),v(3),w(3)
      x1=xv(1)
      y1=yv(1)                                                                  
      x2=xv(2)                                                                  
      y2=yv(2)                                                                  
      xm=(x1+x2)/2                                                              
      ym=(y1+y2)/2                                                              
      if(xm) 1,2,1                                                              
    2 xf=0.                                                                     
      xl=0.                                                                     
      go to 10                                                                  
    1 if(ym) 3,4,3                                                              
    4 yl=0.                                                                     
      yf=0.                                                                     
      go to 11                                                                  
    3 q=ym/xm                                                                   
      xf=-sqrt(1/(d+e*q+f*q*q))
      xl=sqrt(1/(d+e*q+f*q*q))
      yf=q*xf
      yl=q*xl
      go to 20
   10 yf=-1/sqrt(f)
      yl=1/sqrt(f)
      go to 20
   11 xl=-1/sqrt(d)
      yl=1/sqrt(d)
   20 continue
      prodvw=x1*y2-y1*x2
      if(prodvw) 31,31,32
   31 v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
      go to 33
   32 v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
   33 continue
      prodvu=v(1)*yf-v(2)*xf
      if(prodvu) 21,21,12
   21 x=xl
      y=yl
      go to 30
   12 x=xf
      y=yf
   30 continue
      eqell=a*x*x+b*x*y+c*y*y-1
      if(eqell) 40,40,50
   40 jf=1
      jl=ndim-2
      return
   50 jf=2
      jl=ndim-1
      return
      end
c
code for arc1
      subroutine arc1(x1,y1,x2,y2,u1,u2,alfa1,alfa2)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension v(2),w(2)
      pi=3.14159265
      twopi=2*pi
      prod1=x1*u2-y1*u1
      prod2=x2*u2-y2*u1
      cost=prod1*prod2
      if(cost.ge.0.) go to 100
      if(prod1) 1,1,2
    2 v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
      go to 5
    1 v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
    5 continue
      if((abs(w(1)).lt.0.0001).and.(abs(w(2)).lt.0.0001)) go to 209
      if((abs(v(1)).lt.0.0001).and.(abs(v(2)).lt.0.0001)) go to 209
      alfa1=atan2(w(2),w(1))
      alfa2=atan2(v(2),v(1))
      if(alfa1.lt.0) alfa1=alfa1+twopi
      if(alfa2.lt.0) alfa2=alfa2+twopi
      go to 208
  209 if(istat2.gt.0) write(ncwu,991)
  991 format(' attenzione forma indeterminata in arc1 ',
     * 'atan2(w(2),w(1)) o atan2(v(2),v(1))',/)
      alfa1=0.
      alfa2=0.
  208 continue
      return
  100 continue
      vmod1=sqrt(x1*x1+y1*y1)
      vmod2=sqrt(x2*x2+y2*y2)                                                   
      x1n=x1/vmod1                                                              
      y1n=y1/vmod1                                                              
      x2n=x2/vmod2                                                              
      y2n=y2/vmod2                                                              
      prd1=x1n*u2-y1n*u1                                                        
      prd2=x2n*u2-y2n*u1                                                        
      if(prd1.lt.-1.) prd1=-1.                                                  
      if(prd1.gt.1.) prd1=1.                                                    
      if(prd2.lt.-1.) prd2=-1.                                                  
      if(prd2.gt.1.) prd2=1.                                                    
      ro1=asin(prd1)                                                            
      ro2=asin(prd2)                                                            
      if(ro1.gt.ro2) go to 2                                                    
      go to 1                                                                   
      end                                                                       
c
code for ebint
      subroutine ebint(a,b,c,va,vb,t1,t2)
c--intersezioni ellisse retta
      real*8 cc1,cc2,cc3
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension va(3),vb(3)
      t1=-10000
      t2=-10000
      dx=vb(1)-va(1)
      dy=vb(2)-va(2)
      cc1=a*dx*dx+b*dx*dy+c*dy*dy
      cc2=2*a*va(1)*dx+b*va(2)*dx+b*va(1)*dy+2*c*va(2)*dy
      cc3=a*va(1)*va(1)+b*va(1)*va(2)+c*va(2)*va(2)-1.
      if((cc1.eq.0.).or.(cc3.eq.0.)) go to 79
      call s2rad8(cc1,cc2,cc3,t1,t2)
   79 continue
      return
      end
c
code for intpr                                                                  
      subroutine intpr(ell,egv,xa,xb,intp,vint)                                 
c-----real*8 ell
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension ell(2,2),xa(3),xb(3),vint(3),egv(3)
      intp=0
      a1=ell(1,1)
      a2=2.*ell(1,2)
      a3=ell(2,2)
      call ebint(a1,a2,a3,xa,xb,t1,t2)
      if((t1.le.0.).and.(t2.le.0.)) return
      if((t1.ge.1.).and.(t2.ge.1.)) return
      if((t1.le.0.).and.(t2.ge.1.)) return
      if((t2.le.0.).and.(t1.ge.1.)) return
      if((t1.gt.0).and.(t1.lt.1)) go to 10
      if((t2.gt.0).and.(t2.lt.1)) go to 20
   10 intp=1
      vint(1)=xa(1)+t1*(xb(1)-xa(1))
      vint(2)=xa(2)+t1*(xb(2)-xa(2))
      vint(3)=xa(3)+t1*(xb(3)-xa(3))
      go to 30
   20 intp=1
      vint(1)=xa(1)+t2*(xb(1)-xa(1))
      vint(2)=xa(2)+t2*(xb(2)-xa(2))
      vint(3)=xa(3)+t2*(xb(3)-xa(3))
   30 continue
      z=-(egv(1)*vint(1)+egv(2)*vint(2))/egv(3)
      if(z-vint(3)) 1,2,2
    1 continue
      return
    2 intp=0
      return
      end
c
code for elstor
      subroutine elstor(j,a1,a2,a3,a,b,c,ec,a1c,a2c,fic,idr,
     *ex,a1x,a2x,fix,fix1,fix2,ey,a1y,a2y,fiy,fiy1,fiy2,
     *ez,a1z,a2z,fiz,fiz1,fiz2)
c--fornisce tutti gli elementi relativi
c--all'ellissoide i-mo
c-----real*8 ec,ex,ey,ez
      dimension a(3),b(3),c(3),ec(2,2),ex(2,2),ey(2,2),ez(2,2)
      common/xdata/store(800000)
      a1=store(j+1)                                                             
      a2=store(j+2)                                                             
      a3=store(j+3)                                                             
      do 5 i=1,3                                                                
      a(i)=store(j+3+i)                                                         
      b(i)=store(j+6+i)                                                         
      c(i)=store(j+9+i)                                                         
    5 continue                                                                  
      ec(1,1)=store(j+13)                                                       
      ec(1,2)=store(j+14)/2.                                                    
      ec(2,1)=ec(1,2)                                                           
      ec(2,2)=store(j+15)                                                       
      a1c=store(j+16)                                                           
      a2c=store(j+17)                                                           
      fic=store(j+18)                                                           
      if(idr.eq.2) go to 117                                                    
      ex(1,1)=store(j+19)                                                       
      ex(1,2)=store(j+20)/2.                                                    
      ex(2,1)=ex(1,2)                                                           
      ex(2,2)=store(j+21)                                                       
      a1x=store(j+22)                                                           
      a2x=store(j+23)                                                           
      fix=store(j+24)                                                           
      fix1=store(j+25)                                                          
      fix2=store(j+26)                                                          
      ey(1,1)=store(j+27)                                                       
      ey(1,2)=store(j+28)/2.                                                    
      ey(2,1)=ey(1,2)                                                           
      ey(2,2)=store(j+29)                                                       
      a1y=store(j+30)                                                           
      a2y=store(j+31)                                                           
      fiy=store(j+32)                                                           
      fiy1=store(j+33)                                                          
      fiy2=store(j+34)                                                          
      ez(1,1)=store(j+35)                                                       
      ez(1,2)=store(j+36)/2.                                                    
      ez(2,1)=ez(1,2)                                                           
      ez(2,2)=store(j+37)                                                       
      a1z=store(j+38)                                                           
      a2z=store(j+39)                                                           
      fiz=store(j+40)                                                           
      fiz1=store(j+41)                                                          
      fiz2=store(j+42)                                                          
  117 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for ordarc                                                                 
      subroutine ordarc(v,idim,ifus)                                            
c--v: vettore contenente gli archi
c--idim: dimensione effettiva del vattore
c--ifus: numero di fusioni effettuate
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      dimension v(100)
      idim=idim-1                                                               
      if(idim.eq.2) go to 25                                                    
      ifus=0                                                                    
c-- sdoppiamento di intervalli contenenti lo 0                                  
      i=1                                                                       
  200 continue                                                                  
      i2=idim-1                                                                 
      if(i-i2) 31,31,32                                                         
   31 continue                                                                  
      if(v(i).le.v(i+1)) go to 130                                              
      j=i+1                                                                     
      j1=idim+2                                                                 
      j2=j1-2                                                                   
  120 continue                                                                  
      if(j-j2) 21,21,22                                                         
   21 v(j1)=v(j2)                                                               
      j1=j1-1                                                                   
      j2=j2-1                                                                   
      go to 120                                                                 
   22 continue                                                                  
      v(j)=twopi                                                                
      v(j+1)=0.                                                                 
      idim=idim+2                                                               
  130 continue                                                                  
      i=i+2                                                                     
      go to 200                                                                 
   32 continue                                                                  
c------------------------------------------------                               
c-- ordinamento delle coppie di archi secondo il                                
c-- primo elemento della coppia                                                 
      do 10 i=1,idim-3,2                                                        
      do 15 j=i+2,idim-1,2                                                      
      if(v(i)-v(j)) 1,3,2                                                       
    2 continue                                                                  
      com1=v(i)                                                                 
      v(i)=v(j)                                                                 
      v(j)=com1                                                                 
      com2=v(i+1)                                                               
      v(i+1)=v(j+1)                                                             
      v(j+1)=com2                                                               
      go to 1                                                                   
    3 if(v(i+1)-v(j+1)) 1,1,2                                                   
    1 continue                                                                  
   15 continue                                                                  
   10 continue                                                                  
c-----------------------------------------------------------                    
c-- inizio fusione                                                              
      j=2                                                                       
   40 continue                                                                  
      jf=idim-1                                                                 
   45 continue                                                                  
      if(j-jf) 50,50,65                                                         
   50 continue                                                                  
      if(v(j).lt.v(j+1)) go to 60                                               
      if(v(j).gt.v(j+2)) go to 61                                               
      do 55 j1=j,idim                                                           
      v(j1)=v(j1+2)                                                             
   55 continue                                                                  
      ifus=ifus+1                                                               
      idim=idim-2                                                               
      go to 40                                                                  
   61 continue                                                                  
      do 70 j1=j+1,idim                                                         
      v(j1)=v(j1+2)                                                             
   70 continue                                                                  
      ifus=ifus+1                                                               
      idim=idim-2                                                               
      go to 40                                                                  
   60 continue                                                                  
      j=j+2                                                                     
      go to 45                                                                  
   65 continue                                                                  
c-- fine fusione                                                                
      if((v(1).eq.0.).and.(v(idim).eq.twopi)) return                            
   25 v(idim+1)=v(1)                                                            
      idim=idim+1                                                               
      return                                                                    
      end                                                                       
c                                                                               
code for provct                                                                 
      subroutine provct(vl1,vl2,vp)                                             
c--vector product                                                               
      dimension vl1(3),vl2(3),vp(3)                                             
      do 5 i=1,3                                                                
      call seq(i,j,k)                                                           
      vp(i)=vl1(j)*vl2(k)-vl1(k)*vl2(j)                                         
    5 continue                                                                  
      vmod=vp(1)*vp(1)+vp(2)*vp(2)+vp(3)*vp(3)                                  
      vmod=sqrt(vmod)                                                           
      do 10 i=1,3                                                               
      vp(i)=vp(i)/vmod                                                          
   10 continue                                                                  
      return                                                                    
      end                                                                       
c
code for arc
      subroutine arc(x1,y1,x2,y2,alfa1,alfa2)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension v(2),w(2)
      pi=3.14159265
      twopi=2*pi
      prod3=x1*y2-x2*y1
      if(prod3) 1,1,2
    2 v(1)=x1
      v(2)=y1
      w(1)=x2
      w(2)=y2
      go to 5
    1 v(1)=x2
      v(2)=y2
      w(1)=x1
      w(2)=y1
    5 continue
      if((abs(v(1)).lt.0.0001).and.(abs(v(2)).lt.0.0001)) go to 208
      if((abs(w(1)).lt.0.0001).and.(abs(w(2)).lt.0.0001)) go to 208
      alfa1=atan2(w(2),w(1))
      alfa2=atan2(v(2),v(1))
      if(alfa1.lt.0) alfa1=alfa1+twopi                                          
      if(alfa2.lt.0) alfa2=alfa2+twopi                                          
      go to 209
  208 if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in arc1 '
     * 'atan2(w(2),w(1)) o atan2(v(2),v(1))!!'/)
      alfa1=0.
      alfa2=0.
  209 continue
      return                                                                    
      end                                                                       
c
code for eprbn
      subroutine eprbn(e,egv,v,abond,bbond,jdim,int,x1,y1,x2,y2)
c-----real*8 e
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension abond(4,60),bbond(4,60),e(2,2),egv(3),
     *xa(3),xb(3),xc(3),xd(3),v(3),vint(3)
      zero=1.e-06
      a1=e(1,1)
      b1=2.*e(1,2)
      c1=e(2,2)
      int=0
      x1=0.
      y1=0.
      z1=0.
      x2=0.
      y2=0.
      z2=0.
      do 5 j=1,jdim-1
      do 10 i=1,3
      xa(i)=abond(i,j)-v(i)
      xb(i)=bbond(i,j)-v(i)
      xc(i)=abond(i,j+1)-v(i)
      xd(i)=bbond(i,j+1)-v(i)
   10 continue
      k=0
      ell1=a1*xa(1)*xa(1)+b1*xa(1)*xa(2)+c1*xa(2)*xa(2)-1.
      ell2=a1*xb(1)*xb(1)+b1*xb(1)*xb(2)+c1*xb(2)*xb(2)-1.
      ell3=a1*xc(1)*xc(1)+b1*xc(1)*xc(2)+c1*xc(2)*xc(2)-1.
      ell4=a1*xd(1)*xd(1)+b1*xd(1)*xd(2)+c1*xd(2)*xd(2)-1.
      if(abs(ell1).le.zero) ell1=0.
      if(abs(ell2).le.zero) ell2=0.
      if(abs(ell3).le.zero) ell3=0.
      if(abs(ell4).le.zero) ell4=0.
      if(ell1.lt.0.) k=k+1
      if(ell2.lt.0.) k=k+1
      if(ell3.lt.0.) k=k+1
      if(ell4.lt.0.) k=k+1
      if(k) 200,200,100
  100 call intpr(e,egv,xa,xb,intp,vint)
      if(intp) 30,30,40
   40 int=int+1
      if(int-1) 50,50,45
   50 x1=vint(1)
      y1=vint(2)
      z1=vint(3)
      go to 30
   45 x2=vint(1)
      y2=vint(2)
      z2=vint(3)
   30 call intpr(e,egv,xc,xd,intp,vint)
      if(intp) 60,60,70
   70 int=int+1
      if(int-1) 85,80,85
   80 x1=vint(1)
      y1=vint(2)
      z1=vint(3)
      go to 60
   85 x2=vint(1)
      y2=vint(2)
      z2=vint(3)
   60 call intpr(e,egv,xa,xc,intp,vint)
      if(intp) 115,115,95
   95 int=int+1
      if(int-1) 110,105,110
  105 x1=vint(1)
      y1=vint(2)
      z1=vint(3)
      go to 115
  110 x2=vint(1)
      y2=vint(2)
      z2=vint(3)
  115 call intpr(e,egv,xb,xd,intp,vint)
      if(intp) 140,140,125
  125 int=int+1
      if(int-1) 130,135,130
  135 x1=vint(1)
      y1=vint(2)
      z1=vint(3)
      go to 140
  130 x2=vint(1)
      y2=vint(2)
      z2=vint(3)
  140 continue
  200 continue
    5 continue
      return
      end
c
code for eprbn2
      subroutine eprbn2(e,egv,v,abond,bbond,jdim,ve,ndim,nell)
c-----real*8 e
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension abond(4,60),bbond(4,60),v(3),e(2,2),
     *ve(50),egv(3),xa(3),xb(3),x1(100),x2(100)
      zero=0.001
      ndim=0
      nell=0
      do 6 i=1,50
      ve(i)=0.
    6 continue
      a1=e(1,1)
      b1=2*e(1,2)
      c1=e(2,2)                                                                 
      int=0
      kx1=1
      kx2=1
      imem=0
      do 10 j=1,jdim
      ibn=0.
      do 20 i=1,3
      xa(i)=abond(i,j)-v(i)
      xb(i)=bbond(i,j)-v(i)
      if(abs(xa(i)-xb(i)).lt.zero) ibn=ibn+1
   20 continue
      if(ibn-2) 91,25,25
   91 continue
      call ebint(a1,b1,c1,xa,xb,t1,t2)
      if((t1.ge.0).and.(t1.le.1)) go to 15
      go to 25
   15 if((t2.ge.0).and.(t2.le.1)) go to 30
      go to 25
c-- 0<t1<1 0<t2<1
   30 x1(kx1)=xa(1)+t1*(xb(1)-xa(1))
      x1(kx1+1)=xa(2)+t1*(xb(2)-xa(2))
      x1(kx1+2)=xa(3)+t1*(xb(3)-xa(3))
      x1(kx1+3)=j
      x2(kx2)=xa(1)+t2*(xb(1)-xa(1))
      x2(kx2+1)=xa(2)+t2*(xb(2)-xa(2))
      x2(kx2+2)=xa(3)+t2*(xb(3)-xa(3))
      x2(kx2+3)=j
      xint=x1(kx1)
      yint=x1(kx1+1)
      zint=x1(kx1+2)
      z=(-egv(1)*xint-egv(2)*yint)/egv(3)
      if(z-zint) 21,21,25
   21 xint=x2(kx2)
      yint=x2(kx2+1)
      zint=x2(kx2+2)
      z=(-egv(1)*xint-egv(2)*yint)/egv(3)
      if(z-zint) 31,31,25
   31 kx1=kx1+4
      kx2=kx2+4
      imem=imem+1
   25 continue
   10 continue
c-- analisi dei vettori x1 ed x2
      kx1=kx1-1
      kx2=kx2-1
      if(imem) 1000,1000,150
  150 continue
      if(((x1(4).eq.1.).and.(x1(kx1).eq.jdim)).and.
     *((x2(4).eq.1.).and.(x2(kx2).eq.jdim))) go to 65
      if(((x1(4).ne.1.).and.(x1(kx1).eq.jdim)).and.
     *((x2(4).ne.1.).and.(x2(kx2).eq.jdim))) go to 70
      if(((x1(4).eq.1.).and.(x1(kx1).ne.jdim)).and.
     *((x2(4).eq.1.).and.(x2(kx2).ne.jdim))) go to 64
      go to 71
   65 continue
c-- 0<t1<1 0<t2<1
      xx1=x1(1)
      xy1=x1(2)
      xx2=x1(kx1-3)
      xy2=x1(kx1-2)
      xx3=x2(1)
      xy3=x2(2)
      xx4=x2(kx2-3)
      xy4=x2(kx2-2)
      call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
      call arc(xx3,xy3,xx4,xy4,alfa3,alfa4)
      ndim=4
      ve(ndim-3)=alfa2
      ve(ndim-2)=alfa1
      ve(ndim-1)=alfa4
      ve(ndim)=alfa3
      go to 1000
   70 xx1=x1(kx1-3)
      xy1=x1(kx1-2)
      xx2=x2(kx2-3)
      xy2=x2(kx2-2)
      call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
      ndim=2
      ve(ndim-1)=alfa2
      ve(ndim)=alfa1
      go to 1000
   64 xx1=x1(1)
      xy1=x1(2)
      xx2=x2(1)
      xy2=x2(2)
      call arc(xx1,xy1,xx2,xy2,alfa1,alfa2)
      ndim=2
      ve(ndim-1)=alfa2
      ve(ndim)=alfa1
      go to 1000
   71 continue
c     nell=nell+1
 1000 continue
      return
      end
c
code for solv4
      subroutine solv4(aa,bb,cc,dd,ee,x1,x2,x3,x4,im)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      real*8 a,b,c,d,e,b0,b1,b2,b3,b4,p,q,r,c1,c2,c3
      real*8 z1,z2,z3,z4,z5,z6,z7,z8,f1,f2,q1,q2,q3,q4
      real*8 rmod
      real*8 evlr(3),evli(3)
      zero=0.00001
      a=aa
      b=bb
      c=cc
      d=dd
      e=ee
      b0=a/a
      b1=b/a
      b2=c/a
      b3=d/a
      b4=e/a
      p=b2-(3.*b1*b1)/8.
      q=(b1*b1*b1)/8.-(b1*b2)/2.+b3
      r=-(3.*b1*b1*b1*b1)/256.+(b1*b1*b2)/16.-(b1*b3)/4.+b4
      c1=p/2.
      c2=(p*p-4.*r)/16.
      c3=-(q*q)/64.
      call solv3(c1,c2,c3,evlr,evli,im)
      if(im.eq.4) return
      if(im.ne.0) go to 100
      if(evlr(1).le.zero) evlr(1)=0.
      if(evlr(2).le.zero) evlr(2)=0.
      if(evlr(3).le.zero) evlr(3)=0.
      evlr(1)=dsqrt(evlr(1))
      evlr(2)=dsqrt(evlr(2))
      evlr(3)=dsqrt(evlr(3))
      z1=evlr(1)+evlr(2)+evlr(3)
      z2=evlr(1)-evlr(2)-evlr(3)
      z3=-evlr(1)+evlr(2)-evlr(3)
      z4=-evlr(1)-evlr(2)+evlr(3)
      z5=-evlr(1)-evlr(2)-evlr(3)
      z6=-evlr(1)+evlr(2)+evlr(3)
      z7=evlr(1)-evlr(2)+evlr(3)
      z8=evlr(1)+evlr(2)-evlr(3)
      f1=z1*z1*z1*z1+p*z1*z1+q*z1+r
      f2=z5*z5*z5*z5+p*z5*z5+q*z5+r
      if(dabs(f1)-dabs(f2)) 1,1,2
    1 q1=z1
      go to 3
    2 q1=z5
    3 f1=z2*z2*z2*z2+p*z2*z2+q*z2+r
      f2=z6*z6*z6*z6+p*z6*z6+q*z6+r
      if(dabs(f1)-dabs(f2)) 4,4,5
    4 q2=z2
      go to 6
    5 q2=z6
    6 f1=z3*z3*z3*z3+p*z3*z3+q*z3+r
      f2=z7*z7*z7*z7+p*z7*z7+q*z7+r
      if(dabs(f1)-dabs(f2)) 7,7,8
    7 q3=z3
      go to 9
    8 q3=z7
    9 f1=z4*z4*z4*z4+p*z4*z4+q*z4+r
      f2=z8*z8*z8*z8+p*z8*z8+q*z8+r
      if(dabs(f1)-dabs(f2)) 10,10,11
   10 q4=z4
      go to 12
   11 q4=z8
   12 continue
      x1=sngl(q1-b1/4.)
      x2=sngl(q2-b1/4.)
      x3=sngl(q3-b1/4.)
      x4=sngl(q4-b1/4.)
      return
  100 continue
      rmod=dsqrt(evlr(2)*evlr(2)+evli(2)*evli(2))
      rmod=dsqrt(rmod)
      if((dabs(evli(2)).lt.0.0001).and.(dabs(evlr(2)).lt.0.0001))
     1	go to 209
      evli2=sngl(evli(2))
      evlr2=sngl(evlr(2))
      teta=atan2(evli2,evlr2)
      teta=teta/2.
      go to 208
  209 if(istat2.gt.0) write(ncwu,211)
  211 format(' attenzione forma indeterminata in  solv4 '
     * 'atan2(evli(2),evlr(2))',/)
      teta=0.
  208 continue
      evlr(1)=dsqrt(evlr(1))
      z1=evlr(1)+2.*rmod*cos(teta)                                              
      z2=evlr(1)-2.*rmod*cos(teta)                                              
      z3=-evlr(1)-2.*rmod*cos(teta)                                             
      z4=-evlr(1)+2.*rmod*cos(teta)                                             
      f1=z1*z1*z1*z1+p*z1*z1+q*z1+r                                             
      f2=z3*z3*z3*z3+p*z3*z3+q*z3+r                                             
      if(dabs(f1)-dabs(f2)) 13,13,14
   13 q1=z1                                                                     
      go to 15                                                                  
   14 q1=z3                                                                     
   15 f1=z2*z2*z2*z2+p*z2*z2+q*z2+r                                             
      f2=z4*z4*z4*z4+p*z4*z4+q*z4+r                                             
      if(dabs(f1)-dabs(f2)) 16,16,17
   16 q2=z2                                                                     
      go to 18                                                                  
   17 q2=z4                                                                     
   18 continue                                                                  
      x1=sngl(q1-b1/4.)
      x2=sngl(q2-b1/4.)
      return
      end
c
code for solv3
      subroutine solv3(p,q,r,evlr,evli,im)
c--x**3+p*x**2+q*x+r
c--evlr: vettore contenente la parte reale delle soluzioni
c--evli: vettore contenente la parte immaginaria delle soluzioni
c--im=0: la parte immaginaria e nulla
c--im=1: e' presente la parte immaginaria
      dimension angle(3)
      real*8 evlr(3),evli(3),y(3),x(3)
      real*8 p,q,r,r1,r2,d,cost1,cost2,a,b,ca,cb,cs,ct
      zero=0.00001
      do i=1,3
      evli(i)=0.
      evlr(i)=0.
      enddo
      im=0
      pi=3.14159263
      r1=(3.*q-p*p)/3.
      r2=(2.*(p*p*p)-9.*p*q+27.*r)/27.
      d=(r2*r2)/4.+(r1*r1*r1)/27.
      if(d) 50,40,30
   30 continue
c-- 1 radice reale 2 radici complesse coniugate
      d=dsqrt(d)
      cost1=-r2/2.+d
      cost2=-r2/2.-d
      if(cost1) 1,2,2
    1 cost1=dabs(cost1)
      a=cost1**0.333333
      a=-a
      go to 3
    2 a=cost1**0.333333
    3 if(cost2) 4,6,6
    4 cost2=abs(cost2)
      b=cost2**0.333333
      b=-b
      go to 7
    6 b=cost2**0.333333
    7 continue
      evlr(1)=a+b-p/3.
      evlr(2)=-(a+b)/2.-p/3.
      evlr(3)=-(a+b)/2.-p/3.
      if(dabs(evlr(1)).le.zero) evlr(1)=0.
      if(dabs(evlr(2)).le.zero) evlr(2)=0.
      if(dabs(evlr(3)).le.zero) evlr(3)=0.
      evli(1)=0.
      evli(2)=(a-b)/2.*1.732050808
      evli(3)=(a-b)/2.*1.732050808
      im=1
      if(evlr(1).lt.0) im=4
      return
   40 continue
c-- 3 radici reali di cui 2 coincidenti
      if(r2.gt.0) go to 401
      ca=(-r2/2.)**0.333333
      cb=(-r2/2.)**0.333333
      go to 402
  401 ca=(r2/2.)**0.333333
      cb=(r2/2.)**0.333333
      ca=-ca
      cb=-cb
  402 continue
      x(1)=ca+cb
      x(2)=-(ca+cb)/2.
      x(3)=-(ca+cb)/2.
      y(1)=x(1)-p/3.
      y(2)=x(2)-p/3.
      y(3)=x(3)-p/3.
      go to 100
   50 continue
c-- 3 radici reali e distinte
      cs=(-r2/2.)/dsqrt((-(r1*r1*r1))/27.)
      cs2=sngl(cs)
      teta=acos(cs2)
      angle(1)=teta/3.
      angle(2)=(teta/3.)+(2.*pi)/3.
      angle(3)=(teta/3.)+(4.*pi)/3.
      ct=2.*dsqrt(-r1/3.)
      do 55 i=1,3
      x(i)=ct*cos(angle(i))
      y(i)=x(i)-p/3.
   55 continue
  100 continue
c-- eigenvalues sorting
      evlr(1)=dmin1(y(1),y(2),y(3))
      evlr(3)=dmax1(y(1),y(2),y(3))
      evlr(2)=y(1)+y(2)+y(3)-evlr(1)-evlr(3)
      if(dabs(evlr(1)).le.zero) evlr(1)=0.
      if(dabs(evlr(2)).le.zero) evlr(2)=0.
      if(dabs(evlr(3)).le.zero) evlr(3)=0.
      if(evlr(1).lt.0) im=4
      return
      end                                                                       
c                                                                               
code for sost                                                                   
      subroutine sost(x11,x12,y11,y12,a,b,c,                                    
     *an,bn,cn,dn,en,fn,x1,y1)                                                  
      el1=a*x11*x11+b*x11*y11+c*y11*y11-1.                                      
      el2=an*x11*x11+cn*y11*y11+bn*x11*y11                                      
     *+dn*x11+en*y11+fn                                                         
      el3=a*x12*x12+b*x12*y12+c*y12*y12-1.                                      
      el4=an*x12*x12+cn*y12*y12+bn*x12*y12                                      
     *+dn*x12+en*y12+fn                                                         
      if(abs(el2)-abs(el4)) 1,1,2                                               
    1 x1=x11                                                                    
      y1=y11                                                                    
      return                                                                    
    2 x1=x12                                                                    
      y1=y12                                                                    
      return                                                                    
      end                                                                       
c                                                                               
code for dtrasf
      subroutine dtrasf(d,e,f,h,s,an,bn,cn,dn,en,fn)
      an=d
      bn=e                                                                      
      cn=f                                                                      
      dn=-2.*h*d-e*s                                                            
      en=-2.*s*f-e*h                                                            
      fn=d*h*h+e*h*s+f*s*s-1.                                                   
      return                                                                    
      end                                                                       
c                                                                               
code for axbond                                                                 
      subroutine axbond(abond,bbond,p0,p1,jdim,ndim,v)                          
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension abond(4,60),bbond(4,60),v(50),                                  
     *xa(3),xb(3),xc(3),xd(3),p0(3),p1(3)                                       
      tmax=-1000                                                                
      tmin=1000                                                                 
      ndim=0                                                                    
      int=0                                                                     
      do 5 j=1,jdim-1                                                           
      do 10 i=1,3                                                               
      xa(i)=abond(i,j)                                                          
      xb(i)=bbond(i,j)                                                          
      xc(i)=abond(i,j+1)                                                        
      xd(i)=bbond(i,j+1)                                                        
   10 continue                                                                  
      call qdrl(xa,xc,xd,xb,p0,p1,ta,tb,nn)                                     
      if(nn) 1,1,2                                                              
    2 if(ta.lt.tmin) tmin=ta                                                    
      if(tb.gt.tmax) tmax=tb                                                    
      int=int+1                                                                 
    1 continue                                                                  
    5 continue                                                                  
      if(int) 20,20,30                                                          
   30 continue                                                                  
      ndim=ndim+1                                                               
      v(ndim)=tmin                                                              
      v(ndim+1)=tmax                                                            
      ndim=ndim+1                                                               
   20 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for qdrl                                                                   
      subroutine qdrl(a1,a2,a3,a4,p0,p1,ta,tb,nn)                               
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c      dimension a1(3),a2(3),a3(3),a4(3),tt(2),p0(3),p1(3)                      
      dimension a1(3),a2(3),a3(3),a4(3),tt(4),p0(3),p1(3)                       
      nn=0                                                                      
      call fint(p0,p1,a1,a2,t1,q1)                                              
      call fint(p0,p1,a2,a3,t2,q2)                                              
      call fint(p0,p1,a3,a4,t3,q3)                                              
      call fint(p0,p1,a4,a1,t4,q4)                                              
      z1=a1(3)+q1*(a2(3)-a1(3))                                                 
      z2=a2(3)+q2*(a3(3)-a2(3))                                                 
      z3=a3(3)+q3*(a4(3)-a3(3))                                                 
      z4=a4(3)+q4*(a1(3)-a4(3))                                                 
      zt1=p0(3)+t1*(p1(3)-p0(3))                                                
      zt2=p0(3)+t2*(p1(3)-p0(3))                                                
      zt3=p0(3)+t3*(p1(3)-p0(3))                                                
      zt3=p0(3)+t3*(p1(3)-p0(3))                                                
      zt4=p0(3)+t4*(p1(3)-p0(3))                                                
      if(((t1.ge.0.).and.(t1.le.1.)).and.                                       
     *((q1.ge.0.).and.(q1.le.1.))) go to 101                                    
      go to 110                                                                 
  101 if(zt1-z1) 11,11,110                                                      
   11 nn=nn+1                                                                   
c      write(ncwu,*)' 11) nn,t1,q1',nn,t1,q1
      tt(nn)=t1                                                                 
  110 if(((t2.ge.0.).and.(t2.le.1.)).and.                                       
     *((q2.ge.0.).and.(q2.le.1.))) go to 102                                    
      go to 120                                                                 
  102 if(zt2-z2) 12,12,120                                                      
   12 nn=nn+1                                                                   
c      write(ncwu,*)' 12) nn,t2,q2',nn,t2,q2
      tt(nn)=t2                                                                 
  120 if(((t3.ge.0.).and.(t3.le.1.)).and.                                       
     *((q3.ge.0.).and.(q3.le.1.))) go to 103                                    
      go to 130                                                                 
  103 if(zt3-z3) 13,13,130                                                      
   13 nn=nn+1                                                                   
c      write(ncwu,*)' 13) nn,t3,q3',nn,t3,q3
      tt(nn)=t3                                                                 
  130 if(((t4.ge.0.).and.(t4.le.1.)).and.                                       
     *((q4.ge.0.).and.(q4.le.1.))) go to 105                                    
      go to 150                                                                 
  105 if(zt4-z4) 14,14,150                                                      
   14 nn=nn+1                                                                   
c      write(ncwu,*)' 14) nn,t4,q4',nn,t4,q4
      tt(nn)=t4                                                                 
  150 continue                                                                  
      if(nn-1) 200,210,220                                                      
  220 continue                                                                  
      ta=9999.
      tb=-9999.
      do jj=1,nn
      ta=amin1(tt(jj),ta)
      tb=amax1(tt(jj),tb)
      enddo
      go to 200                                                                 
  210 continue                                                                  
      call intest(a1,a2,a3,a4,p0,p1,n0)                                         
      if(n0) 300,310,310                                                        
  300 continue                                                                  
      ta=tt(1)                                                                  
      tb=1.                                                                     
      go to 200                                                                 
  310 ta=0.                                                                     
      tb=tt(1)                                                                  
  200 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for intest                                                                 
      subroutine intest(a1,a2,a3,a4,a5,a6,n0)                                   
c--n0=-1 :il punto p0 e' esterno
c--n0=0  :il punto p0 e' sulla frontiera
c--n0=1  :il punto p0 e' interno
      dimension a1(3),a2(3),a3(3),a4(3),a5(3),a6(3),
     *fl(4,3),sfla0(4),sfla1(4),a(4,3)                                          
      n0=-1
      do 5 i=1,3                                                                
      a(1,i)=a5(i)-a1(i)                                                        
      a(2,i)=a5(i)-a2(i)                                                        
      a(3,i)=a5(i)-a3(i)                                                        
      a(4,i)=a5(i)-a4(i)                                                        
      fl(1,i)=a2(i)-a1(i)                                                       
      fl(2,i)=a3(i)-a2(i)                                                       
      fl(3,i)=a4(i)-a3(i)                                                       
      fl(4,i)=a1(i)-a4(i)                                                       
    5 continue                                                                  
      do 10 i=1,4                                                               
      sfla0(i)=fl(i,1)*a(i,2)-fl(i,2)*a(i,1)                                    
   10 continue                                                                  
      do 15 i=1,3                                                               
      a(1,i)=a6(i)-a1(i)                                                        
      a(2,i)=a6(i)-a2(i)                                                        
      a(3,i)=a6(i)-a3(i)                                                        
      a(4,i)=a6(i)-a4(i)                                                        
   15 continue                                                                  
      do 20 i=1,4                                                               
      sfla1(i)=fl(i,1)*a(i,2)-fl(i,2)*a(i,1)
   20 continue                                                                  
      prod0=sfla0(1)*sfla0(2)*sfla0(3)*sfla0(4)                                 
      if(prod0.eq.0.) go to 100                                                 
      iplus=0                                                                   
      imin=0                                                                    
      do 25 i=1,4                                                               
      if(sfla0(i).gt.0.) iplus=iplus+1                                          
      if(sfla0(i).lt.0.) imin=imin+1                                            
   25 continue                                                                  
      if((iplus.eq.4).or.(imin.eq.4)) n0=1                                      
      return                                                                    
  100 n0=0                                                                      
      return                                                                    
      end                                                                       
c                                                                               
code for axl                                                                    
      subroutine axl(va,pa,pb,ell,nax,ndim,v)                                   
c--calcolo intersezioni assi--ellissi
      dimension va(3),pa(3),pb(3),v(10),ell(2,2),p0(3),p1(3),                   
     *egv(3),v1(3),v2(3)                                                        
      ndim=0                                                                    
      do 11 i=1,10                                                              
      v(i)=0.                                                                   
   11 continue                                                                  
      do 10 i=1,3                                                               
      p0(i)=pa(i)-va(i)                                                         
      p1(i)=pb(i)-va(i)                                                         
   10 continue                                                                  
      if(p0(3)) 50,50,500                                                       
   50 continue                                                                  
      a=ell(1,1)                                                                
      b=2*ell(1,2)                                                              
      c=ell(2,2)                                                                
      ell0=a*p0(1)*p0(1)+b*p0(1)*p0(2)+c*p0(2)*p0(2)-1.                         
      ell1=a*p1(1)*p1(1)+b*p1(1)*p1(2)+c*p1(2)*p1(2)-1.                         
      call ebint(a,b,c,p0,p1,t1,t2)                                             
      if((ell0.lt.0.).and.(ell1.lt.0.)) go to 100                               
      if((t1.lt.0.).and.(t2.lt.0.)) return                                      
      if((t1.gt.1.).and.(t2.gt.1.)) return                                      
      if((t1.lt.0.).and.(t2.gt.1.)) return                                      
      if((t2.lt.0.).and.(t1.gt.1.)) return                                      
      if(((t1.ge.0.).and.(t1.le.1.)).and.                                       
     *((t2.ge.0.).and.(t2.le.1.))) go to 200                                    
      if((t1.ge.0.).and.(t1.le.1.)) t=t1                                        
      if((t2.ge.0.).and.(t2.le.1.)) t=t2                                        
      if(ell0.lt.0.) go to 300                                                  
      if(ell1.lt.0.) go to 400                                                  
  300 ndim=ndim+1                                                               
      v(ndim)=0.                                                                
      v(ndim+1)=t                                                               
      ndim=ndim+1                                                               
      go to 500                                                                 
  400 ndim=ndim+1                                                               
      v(ndim)=t                                                                 
      v(ndim+1)=1.                                                              
      ndim=ndim+1                                                               
      go to 500                                                                 
  200 continue                                                                  
      ndim=ndim+1                                                               
      v(ndim)=t1                                                                
      v(ndim+1)=t2                                                              
      ndim=ndim+1                                                               
      go to 500                                                                 
  100 nax=nax+1                                                                 
  500 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for axell                                                                  
      subroutine axell(va,vb,ell,p0,p1,egv,ndim,v)                              
c--calcolo intersezioni assi--ellissi
      dimension va(3),vb(3),v(10),ell(2,2),p0(3),p1(3),                         
     *egv(3),v1(3),v2(3)                                                        
      real*8 cc1,cc2,cc3
c
      ndim=0
      do 11 i=1,10                                                              
      v(i)=0.                                                                   
   11 continue                                                                  
      h=vb(1)-va(1)                                                             
      s=vb(2)-va(2)                                                             
      d=ell(1,1)                                                                
      e=ell(1,2)*2.                                                             
      f=ell(2,2)                                                                
      call dtrasf(d,e,f,h,s,a1,b1,c1,d1,e1,f1)
      dx=p1(1)-p0(1)                                                            
      dy=p1(2)-p0(2)                                                            
      cc1=a1*dx*dx+b1*dx*dy+c1*dy*dy                                            
      cc2=2.*a1*p0(1)*dx+b1*p0(1)*dy+b1*p0(2)*dx+2.*c1*p0(1)*dy                 
     *+d1*dx+e1*dy                                                              
      cc3=a1*p0(1)*p0(1)+b1*p0(1)*p0(2)+c1*p0(2)*p0(2)                          
     *+d1*p0(1)+e1*p0(2)+f1-1.                                                  
      call solv2(cc1,cc2,cc3,t1,t2)                                             
      if((t1.le.0.).and.(t2.le.0.)) return                                      
      if((t1.ge.1.).and.(t2.ge.1.)) return                                      
      if((t1.le.0.).and.(t2.ge.1.)) return                                      
      if((t2.le.0.).and.(t1.ge.1.)) return                                      
      if((t1.le.0.).or.(t1.ge.1)) go to 20                                      
      v1(1)=p0(1)+t1*(p1(1)-p0(1))                                              
      v1(2)=p0(2)+t1*(p1(2)-p0(2))                                              
      v1(3)=p0(3)+t1*(p1(3)-p0(3))                                              
      z=(-egv(1)*v1(1)-egv(2)*v1(2))/v1(3)                                      
      if(v1(3)-z) 1,1,20                                                        
    1 ndim=ndim+1                                                               
      v(ndim)=t1                                                                
   20 if((t2.le.0.).or.(t2.ge.1.)) go to 30                                     
      v2(1)=p0(1)+t2*(p1(1)-p0(1))                                              
      v2(2)=p0(2)+t2*(p1(2)-p0(2))                                              
      v2(3)=p0(3)+t2*(p1(3)-p0(3))                                              
      z=(-egv(1)*v2(1)-egv(2)*v2(2))/egv(3)                                     
      if(v2(3)-z) 3,3,30                                                        
    3 ndim=ndim+1                                                               
      v(ndim)=t2                                                                
   30 continue                                                                  
      return                                                                    
c   10 ndim=ndim+1                                                               
c      v(ndim)=0.                                                                
c      ndim=ndim+1                                                               
c      v(ndim)=1.                                                                
c      return                                                                    
      end                                                                       
c                                                                               
code for pltab
      subroutine pltab(va,vb,a,b,num,jdim)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcost/zero,eps0,n1,n2,n3,n4,n5,n6,n7,n8,
     *nbon,nst,iline,istep,lcom1,ielem,kstep,nind,mind,
     *sbn(50),ivett,icost(130)
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      dimension va(3),vb(3),a(4,60),b(4,60)                                     
      do 100 j=1,jdim                                                           
      do 200 i=1,3                                                              
      store(nfl)=a(i,j)+va(i)                                                   
      nfl=nfl+1                                                                 
      num=num+1                                                                 
  200 continue                                                                  
      store(nfl)=a(4,j)                                                         
      nfl=nfl+1                                                                 
      num=num+1                                                                 
      do 300 i=1,3                                                              
      store(nfl)=b(i,j)+vb(i)                                                   
      nfl=nfl+1                                                                 
      num=num+1                                                                 
  300 continue                                                                  
      store(nfl)=b(4,j)                                                         
      nfl=nfl+1                                                                 
      num=num+1                                                                 
  100 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for ordv                                                                   
      subroutine ordv(inum,icoun,v,jfus)                                        
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension v(100)                                                          
      do 100 i=1,icoun                                                          
      if(v(i).lt.0) v(i)=0.                                                     
      if(v(i).gt.1) v(i)=1.                                                     
  100 continue                                                                  
      if(istat2-1) 6001,6001,6002                                               
 6002 write(ncwu,101) (v(i),i=1,icoun)                                          
  101 format(1x,'v=',10f10.5)                                                   
 6001 continue                                                                  
      if(inum.eq.2) go to 1000                                                  
c-- ordinamento posti pari                                                      
      do 10 i=2,icoun-2,2                                                       
      do 15 i1=i+2,icoun,2                                                      
      if(v(i).le.v(i1)) go to 5                                                 
      com1=v(i)                                                                 
      v(i)=v(i1)                                                                
      v(i1)=com1                                                                
    5 continue                                                                  
   15 continue                                                                  
   10 continue                                                                  
      if(istat2-1) 7001,7001,7002                                               
 7002 write(ncwu,1) (v(i),i=1,icoun)                                            
    1 format(1x,'v-',10f10.5)                                                   
 7001 continue                                                                  
c-- ordinamento posti dispari                                                   
      do 20 i=1,icoun-3,2                                                       
      do 25 i1=i+2,icoun-1,2                                                    
      if(v(i).le.v(i1)) go to 70                                                
      com1=v(i)                                                                 
      v(i)=v(i1)                                                                
      v(i1)=com1                                                                
   70 continue                                                                  
   25 continue                                                                  
   20 continue                                                                  
c-------------                                                                  
      if(istat2-1) 8001,8001,8002                                               
 8002 write(ncwu,1) (v(i),i=1,icoun)                                            
 8001 continue                                                                  
c-- fusione di intervalli                                                       
 1000 continue                                                                  
      jfus=0.                                                                   
      j=2                                                                       
   40 continue                                                                  
      jf=inum+2                                                                 
   45 continue                                                                  
      if(j-jf) 50,50,65                                                         
   50 continue                                                                  
      if(v(j).lt.v(j+1)) go to 60                                               
      do 55 j1=j,inum+4                                                         
      v(j1)=v(j1+2)                                                             
   55 continue                                                                  
      jfus=jfus+1                                                               
      inum=inum-2                                                               
c     icoun=icoun-2                                                             
      go to 40                                                                  
   60 continue                                                                  
      j=j+2                                                                     
      go to 45                                                                  
   65 continue                                                                  
      return                                                                    
      end
c
code for fint                                                                   
      subroutine fint(va,vb,vc,vd,ti,qj)                                        
c--controllo di intersezioni fra le generatrici dei coni
      dimension va(3),vb(3),vc(3),vd(3)                                         
      zero=0.001                                                                
      dx1=vb(1)-va(1)                                                           
      dy1=vb(2)-va(2)                                                           
      dx2=vd(1)-vc(1)                                                           
      dy2=vd(2)-vc(2)                                                           
      det=dx2*dy1-dx1*dy2                                                       
      if(abs(det).lt.zero) go to 10                                             
      ti=(dx2*(vc(2)-va(2))-dy2*(vc(1)-va(1)))/det                              
      qj=(dx1*(vc(2)-va(2))-dy1*(vc(1)-va(1)))/det                              
      return                                                                    
   10 continue                                                                  
      ti=-10                                                                    
      qj=-10                                                                    
      return                                                                    
      end
c
code for lat                                                                    
      subroutine lat(ity1,a,mark)                                               
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      na=ndat(ity1,a,n25,l25,md25,lk)                                           
      if(na.eq.1) go to 5                                                       
      store(lk+12)=store(lk+12)+mark                                            
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for lsq                                                                    
      subroutine lsq(ity1,a,ity2,b,mark)                                        
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      nb=ndat(ity1,a,n25,l25,md25,lb)                                           
      if(nb.eq.1) go to 30                                                      
      ne=ndat(ity2,b,n25,l25,md25,le)                                           
      if(ne.eq.1) go to 30                                                      
      m25=l25                                                                   
      do 20 i=1,n25                                                             
      m25i=m25                                                           
      if((m25.ge.lb).and.(m25.le.le)) go to 5                                   
      go to 15                                                                  
    5 continue                                                                  
      store(m25+12)=store(m25+12)+mark                                          
   15 continue                                                                  
      m25=m25+md25                                                              
   20 continue                                                                  
   30 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for ltyp                                                                   
      subroutine ltyp(ity1,mark)                                                
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 5 i=1,n25                                                              
      m25i=m25                                                           
      if(istore(m25i)-ity1) 10,15,10                                            
   15 continue                                                                  
      store(m25+12)=store(m25+12)+mark                                          
   10 continue                                                                  
      m25=m25+md25                                                              
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for lall                                                                   
      subroutine lall(mark)                                                     
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 5 i=1,n25                                                              
      m25i=m25                                                           
      store(m25+12)=store(m25+12)+mark                                          
      m25=m25+md25                                                              
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for rlab                                                                   
      subroutine rlab(mark)                                                     
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      m25=l25                                                                   
      do 5 i=1,n25                                                              
      m25i=m25                                                           
      if(store(m25+12).ge.10) store(m25+12)=store(m25+12)-mark                  
      m25=m25+md25                                                              
    5 continue                                                                  
      return                                                                    
      end                                                                       
c                                                                               
code for symbol
      subroutine symbol(nlt)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/lst25/l25,m25,md25,n25
      common/xhp/xplo1,yplo1,xplo2,yplo2,p1x,p1y,p2x,p2yn,itrmn,
     *h(1),r(1)
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)
      dimension at(3)
      m25=l25
      do 10 i=1,n25
      if(store(m25+12).lt.10) go to 15
c-- l'atomo e' fleggato
      call stor(m25,at)
      if(nlt.eq.1) go to 20
      call poly(nlt,at)
      go to 15
   20 continue
      call star(at)
   15 continue
      m25=m25+md25
   10 continue
      mark=10
      call rlab(mark)
      call plrst
      return
      end
c
code for wrlab
      subroutine wrlab(m25,ilbl,j)                                              
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,ic,ia,ih                                            
      common/xhp/xplo1,yplo1,xplo2,yplo2,p1x,p1y,p2x,p2y,h(1),r(1)
      common/xhpch/itrmn
      common/xdata/store(800000)
      dimension istore(800000)
      equivalence(store,istore)                                                 
      dimension ilbl(10)
c--
      m25h=m25+13                                                        
      do 5 i=1,10
      ilbl(i)=ib                                                                
    5 continue                                                                  
      l1=m25h                                                                   
      l2=m25h+3
      j=1
      do 10 i=l1,l2                                                             
      ilbl(j)=istore(i)
      if(ilbl(j).ne.ib) j=j+1
   10 continue                                                                  
      j=j+1                                                                     
      ilbl(j)=itrmn                                                             
      write(ncwu,20) (istore(m25+ll),ll=m25h,m25h+1)                            
   20 format(1x,2a4)                                                            
      return                                                                    
      end                                                                       
