c
code for geom
      subroutine geom
c--dummy routine to identify the module
      return
      end
c
code for weox
      subroutine weox(idev,jcod)
c--read molecular geometry directives
c  jcod 0 read directives
c	1 dist for cif file
c	2 ang  for cif file
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,mnnfl,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idv
      character*60 carctr
      common/cfile/ carctr
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/xfour/ncol,ndev,nfix
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/lst02/ic,il,g2,isys,ngen,l2,mm2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/icomc(200)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
c--from parst96
      double precision m1,m2,m3,m4,up,cp
      common/ins1/m1,m2,m3,m4
      common/lbl2/cp,up,nn
c--end
      dimension hl(12)
      dimension itarg(19)
      character*40 iarg
      character*40 itst1
      character*1  ixx
      data itst1/'the file name !'/
      data ixx/'>'/
      data iarg/'instruction(s) or ##'/
      data itarg/  4hp3p ,4hpnr ,4hpp2 ,4hpqm ,4hprz ,
     2		   4hrqm ,4htor ,4happ ,4harp ,4hall ,
     3		   4hdpa ,4hdra ,4hpm  ,4hangl,4hdist,
     3		   4hsave,4htabl,4hcif ,4hend /
      data nat/19/
      if(jcod.eq.0)then
c--read the list
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*3
      m2p=l2p
      do 1001 i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
 1001 continue
      call xfl05
c--end of reading the list
      end if
      m1=32007779d0
      m2=23717810d0
      m3=52636370d0
      cp=1d0
      nn=200
      up=1d0/(cp*dsqrt(1d0*nn))
c--
      idv = idev
      ncol=0
      ndev=0
      nfix=0
      isave=0
      jcif=0
c--partial list :
c  25  atoms  : ty sn x y z d(x) d(y) d(z) [name addrress]
c  26  lines  :     ( as above)
c  27  planes : name u v w d d(u) d(v) d(w) d(d) (not used)
c
      mnnfl=nfl
      l25 = nfl
      l26 = nfl
      l27 = nfl
      md27=10
      l27b=lfl-md27+1
      lfl=lfl-200
      n27b=0
      l27a=l27b
1000  continue
      nfl = mnnfl
      md25=9
      md26=9
      md27=10
      n25=0
      n26=0
      n27=0
      if(jcod.ne.0)then
c--write cif file by external call
	if(nopen(nctu,ier)) 9100,920,920
920	continue
	jcif=1
	isave=1
	ncol=1
	idv=1
	aa=0.0
	bb=0.0
	goto(810,820),jcod
c--bond distances
810	continue
	call cdis(aa,bb)
	goto 830
c--bond angles
820	continue
	call cans(aa,bb)
830	continue
	icod=0
	write(nctu) icod
	call ptable
	close(nctu)
	return
      end if
      call xline
      if(jeodr(in)) 9000,1010,2040
1010  continue
      call sty(iarg)
c
c--main loop for processing input instructions
c--fetch the next card
 2000 continue
      if(klnc(j)) 9000,2020,9000
c-- card to be interpreted
 2020 continue
      call xpcci
      if(jrca(itemp(1),n)) 2060,2040,2060
c--process the directive
 2040 continue
      n=kcomp(1,itemp(1),itarg,nat,1)
      if(n) 2051,2051,2050
 2050 continue
      i25=25
      i26=26
      i27=27
      li25=125
      li26=126
      li27=127
      li = l25+n25*md25-1
      call xsac (i25,li25,l25,li)
      li = l26+n26*md26-1
      call xsac(i26,li26,l26,li)
      li = l27+n27*md27-1
      call xsac(i27,li27,l27,li)
      i127=127
      call xsac(i127,li27,l27a,l27b)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xline
      call xpas
 5000 continue
      jn=n
      go to (2100,2100,2100,2100,2200,2500,2600,
     1 2700,2710,2720,2730,2740,2750,
     2 3000,3100,2800,2900,3200,
     3 9000,2051),jn
 2051 continue
      call xunkw
      go to 2000
2060  continue
      call xmhf
      go to 2000
c
c--'p3p','pnr','pp2','pqm'        directives
2100   continue
      if(n25.eq.0) goto 2060
      if(jrca(itemp(1),n)) 2060,2110,2060
2110  name=itemp(1)
      go to (2120,2130,2140,2150),jn
c--'p3p' directive
2120  continue
      call cp3p(name)
      go to 1000
c--'pnr' directive
2130  continue
      call cpnr(name)
      go to 1000
c--'pp2' directive
2140  continue
c      call cpp2(name)
      goto 1000
c--'pqm' directive
2150  continue
      call cpqm(name)
      go to 1000
c
c--'prz' directive
2200  continue
      if(n25.eq.0) goto 2060
      iln=0
      call cprz(iln)
      goto 1000
c
c--'rqm' directive
2500  continue
      if(n25.eq.0) goto 2060
      call crqm
      go to 1000
c
c--'tor' directive
2600  continue
      if(n25.eq.0) goto 2060
      call ctor
      go to 1000
c
c--'app' directive
2700  continue
      if(n27.eq.0) goto 2060
      call capp
      go to 1000
c
c--'arp' directive
2710  continue
      if(n26.eq.0.or.n27.eq.0) goto 2060
      call carp
      go to 1000
c
c--'all' directive
2720  continue
      if(n26.eq.0) goto 2060
      call callc
      go to 1000
c
c--'dpa' directive
2730  continue
      if(n25.eq.0.or.n27.eq.0) goto 2060
      call cdpa
      go to 1000
c
c--'dra' directive
2740  continue
      if(n25.eq.0.or.n26.eq.0) goto 2060
      call cdra
      go to 1000
c
c--'pm ' directive
2750  continue
      if(n25.eq.0) goto 2060
      call cpm
      goto 1000
c
c--'ang' directive
3000  continue
      if(jredf(temp,2)) 2060,3010,3010
3010  continue
      aa=temp(1)
      bb=temp(2)
      if(aa.le.0)aa=0.2
      if(bb.le.0)bb=1.7
      call cans(aa,bb)
      go to 1000
3100  continue
c
c---'dist' directive
      if(jredf(temp,2)) 2060,3110,3110
3110  continue
      aa=temp(1)
      bb=temp(2)
      if(aa.le.0) aa=0.2
      if(bb.le.0) bb=1.7
      call cdis(aa,bb)
      go to 1000
c
c--'save' directive
2800  continue
      if(nopen(nctu,ier)) 9100,2810,2810
2810  continue
      isave=1
      go to 1000
c
c--'table' directive
2900  continue
      if(isave.eq.0) goto 2051
      ncol=kredi(i)
      ndev=kredi(i)
      nfix=kredi(i)
      icod=0
      write(nctu) icod
      call ptable
      close(nctu)
      isave=0
      goto 1000
c
c--'cif  ' directive
3200  continue
      if(nopen(nctu,ier)) 9100,3210,3210
3210  continue
      call sty(itst1)
      call styb(ixx)
      carctr=' '
      read(ncru,'(a)') carctr
      do 5711 i=1,39
      if(carctr(i:i).eq.'#') goto 1010
5711  continue
      write(ncwu,5715) carctr
5715  format(/,' cif file = ',a,/)
      if(iopen(ncpu,carctr,ier)) 9100,5716,5716
5716  continue
      jcif=1
      isave=1
      ncol=1
      idv=1
      goto 1000
c
c--'end' directive
9000  continue
      if(jcif.eq.0.and.isave.eq.0) goto 9050
      icod=0
      write(nctu) icod
      call ptable
      close(nctu)
      isave=0
9050  continue
      return
9100  continue
      write(ncwu,9110) ier
9110  format(' weox error:',i5)
      call xerr
      return
      end
c
code for ptable
      subroutine ptable
c--print distances or angles for publication
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,icc,ia,ih ,numb(10),iplus, inus,ipoint
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,mnnfl,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idv
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/xfour/ncol,ndev,nfix
      common/lst25/l25,m25,md25,n25
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
c--
      dimension linea(130),jyes(3)
      data jyes/1hy,1he,1hs/
      data jsta/4h****/
c--
      rewind nctu
      sumdist=0.0
      numdist=0.0
      sumdev2=0.0
      if(ncol.eq.0) ncol=2
      if(jcif.eq.1) ncol=1
      if(ndev.eq.0) ndev=1
      ndeci=3
      if(nfix.gt.0) then
       ndeci=nfix
       nfix=1
      end if
      m25=l25
      md25=14
      icod1=0
1000  continue
      read(nctu) icod
900   if(icod) 1010,1005,1010
1005  if(icod1) 1100,9000,1100
1010  continue
      if(m25-l25) 1020,1020,1025
1020  icod1=icod
      goto 1030
1025  if(icod.ne.icod1) goto 1100
1030  read(nctu)(itemp(i),i=1,12),a,b
      do 1035 i=1,12
      if(itemp(i).ne.jsta) goto 1037
1035  continue
      goto 1000
1037  m=m25
      do 1045 i=1,12
      istore(m)=itemp(i)
1045  m=m+1
      store(m25+12)=a
      store(m25+13)=b
      n25=n25+1
      m25=m25+md25
      goto 1030
c
c--table of distances
1100  continue
      if(istat2.eq.0) goto 1130
      m25=l25
      do 1110 i=1,n25
      write(ncwu,1120) (istore(m),m=m25,m25+11),store(m25+12),
     2 store(m25+13)
1120  format(1x,3(4a2,'- '),2f10.3)
      m25=m25+md25
1110  continue
1130  continue
      jm=n25/ncol
      if(n25.eq.jm*ncol) goto 1135
      jm=jm+1
      m25=l25+md25*n25
      n25=n25+1
      store(m25+12)=-1.0
1135  jn=50
      if(jcif.ne.0)jn=jm
      jp=jm/jn
      if(jm.gt.jp*jn) jp=jp+1
      m25=l25
c--prepare the table
      m25x=l25
      nn=n25
      do 1300 ja=1,jp
c      call xline
      if(ja.gt.1)goto1170
      if(icod1)1172,9000,1174
1172  continue
      if(jcif.eq.0) then
	write(ncwu,1166)
1166	format(/,' Table   . Bond lengths (A) with e.s.d.',1h',
     1	's in parentheses',//)
      else
	write(ncpu,2000)
2000	format('  ',/,'  ',/,
     1	       'loop_',/,
     2	       '_geom_bond_atom_site_label_1',/,
     3	       '_geom_bond_atom_site_label_2',/,
     4	       '_geom_bond_distance',/,
     5	       '_geom_bond_site_symmetry_1',/,
     6	       '_geom_bond_site_symmetry_2',/,
     7	       '_geom_bond_publ_flag')
      end if
      goto 1178
1174  continue
      if(jcif.eq.0) then
      write(ncwu,1175)
1175  format(/,' Table    . Bond angles (',a1,') with e.s.d.',1h',
     1 's in parentheses',//)
      else
	write(ncpu,2010)
2010	format('  ',/,'  ',/,
     1	       'loop_',/,
     2	       '_geom_angle_atom_site_label_1',/,
     3	       '_geom_angle_atom_site_label_2',/,
     4	       '_geom_angle_atom_site_label_3',/,
     5	       '_geom_angle                  ',/,
     6	       '_geom_angle_site_symmetry_1  ',/,
     7	       '_geom_angle_site_symmetry_2  ',/,
     8	       '_geom_angle_site_symmetry_3  ',/,
     9	       '_geom_angle_publ_flag')
       end if
       goto 1178
1170  if(jcif.eq.0) write(ncwu,1168)
1168  format(/,10x,'continuing..........',//)
1178  mm=jn*ncol
      if(mm.gt.nn) mm=nn
      nn=nn-mm
      m25=m25x
      mm2=mm/ncol
      do 1200 jb=1,mm2
      do 1210 k=1,120
1210  linea(k)=ib
      nx=8
      k=1
      call slinea(m25,nx,k,linea)
      if(jcif.eq.0) linea(nx+1)=inus
      j=nx+3
      m=m25+4
      call slinea(m,nx,j,linea)
      jf=2*nx+3
      if(icod1) 1220,9000,1215
1215  j=nx+2+nx
      if(jcif.eq.0) linea(j+1)=inus
      j=j+3
      m=m25+8
      call slinea(m,nx,j,linea)
      jf=3*nx+4
1220  continue
      a=store(m25+12)
      b=store(m25+13)
c--sommo i valori
      sumdist=sumdist+a
      numdist=numdist+1
      sumdev2=sumdev2+b*b
      je=0
      jf=jf+8
      call snum(a,b,ndeci,je,jf,linea,ndev,nfix)
      if(jcif.eq.1) then
       jf=40
       do i=1,2
       linea(jf)=ipoint
       jf=jf+2
       enddo
       if(icod1.gt.0) then
	linea(jf)=ipoint
	jf=jf+2
       endif
       jf=jf+2
       do i=1,3
       linea(jf)=jyes(i)
       jf=jf+1
       enddo
      endif
      if(ncol.eq.1) goto 1250
      m25a=m25+mm2*md25
      if(store(m25a+12)) 1250,1235,1235
1235  continue
      k1=35
      if(icod1.gt.0) k1=43
      call slinea(m25a,nx,k1,linea)
      linea(k1+nx+1)=inus
      j=k1+nx+3
      m=m25a+4
      call slinea(m,nx,j,linea)
      jf=k1+2*nx+3
      if(icod1) 1230,9000,1237
1237  j=k1+nx+2+nx
      linea(j+1)=inus
      j=j+3
      m=m25a+8
      call slinea(m,nx,j,linea)
      jf=k1+3*nx+4
1230  a=store(m25a+12)
      b=store(m25a+13)
c--somma i valori
      sumdist=sumdist+a
      numdist=numdist+1
      sumdev2=sumdev2+b*b
      je=0
      jf=jf+8
      call snum(a,b,ndeci,je,jf,linea,ndev,nfix)
1250  continue
      call endlin(linea,120,nfin)
      if (jcif.eq.0) then
	write(ncwu,1260) (linea(k),k=1,nfin)
1260	format(1x,120a1)
      else
	write(ncpu,1260) (linea(k),k=1,nfin)
      end if
      m25=m25+md25
1200  continue
      m25x=m25x+mm*md25
1300  continue
c      call xline
      if (jcif.eq.0) then
      sumdist=sumdist/numdist
      sumdev2=sqrt(sumdev2/numdist)
      write(ncwu,1310)	sumdist,sumdev2
1310  format(/,' valore medio:',f10.3,/,
     1	       ' errore medio:',f10.3)
      endif
      m25=l25
      n25=0
      icod1=0
      goto 900
c--exit
9000  continue
      return
      end
c
code for endlin
      subroutine endlin(linea,lengh,nfin)
c--find the last character not blank
c
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      dimension linea(*)
c
      do 1000 i=lengh,1,-1
      nfin=i
      if(linea(i).ne.ib) return
1000  continue
      return
      end
c
code for slinea
      subroutine slinea(m1,nx,n1,linea)
c--insert in the printing buffer
c
c  m1 address of the atom name in istore vector
c  nx maximum lenght (in character)  of the name
c  n1 address in the buffer
c  linea : printing buffer
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      dimension linea(*)
      character*40 nome
c--
      do 1213 k=1,8
1213  itemp(k)=ib
      call scar(istore(m1),itemp,4)
      j=n1
      write(nome,'(a1)')itemp(1)
      call xupcase(nome)
      read(nome,'(a1)')itemp(1)
      do 1230 k=1,nx
      linea(j)=itemp(k)
      j=j+1
1230  continue
      return
      end
c
code for cpp2
c      subroutine cpp2(name)
c      return
c      end
c
code for cp3p
      subroutine cp3p(nam)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,mnnfl,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),xr(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m25=l25
      lb=m25+2
      lc=lb+md25
      ld=lc+md25
      le=l27a+1
      write(ncwu,21)
   21 format(/,' the plane through the atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      write(ncwu,10)
   10 format(' ... is (in the form a*x+b*y+c*z=d):')
      jx = 9
      call scamb (l1m1,gg,jx)
      call scamb (l1m2,gr,jx)
      jx = 3
      call scamb (lb,x1,jx)
      call scamb (lc,x2,jx)
      call scamb (ld,x3,jx)
      call p3pc (x1,x2,x3,gg,gr,xr)
      jx = 4
      call bmacs(le,xr,jx)
      l27i = l27a
      istore(l27i) = nam
      n27b= n27b+1
      i1=1
      call cwrl(l27a,i1,md27)
      l27a = l27a -md27
      return
      end
c
code for p3pc
      subroutine p3pc(x1,x2,x3,g,gr,pr)
c
c     plane defined by 3 points
c
      dimension x1(3),x2(3),x3(3),g(9),gr(9)
      dimension a(3),b(3),c(3),cr(3),pr(4)
      call vcmp(x1,x2,a)
      call vcmp(x3,x2,b)
      call vpr(g,a,b,cr)
      call mv(gr,cr,c)
      call ospr(c,cr,q)
      q=sqrt(q)
      do 100 i=1,3
      cr(i)=cr(i)/q
      pr(i)=cr(i)
  100 continue
      call ospr(cr,x2,d)
      pr(4)=d
      return
      end
c
code for cpnr
      subroutine cpnr(name)
c     common generale
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),xr(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m26=l26
      lb=m26+2
      lc=lb+md26
      m25=l25
      ld=m25+2
      le=l27a+1
      write(ncwu,2)
    2 format (/,' plane normal the line:')
      i2=2
      call xwrl(l26,i2 ,md26)
      if(istat2.ne.0) call cwrl(l26,i2 ,md26)
      write(ncwu,3)
    3 format(' ...and through the atom:')
      i1=1
      call xwrl(l25,i1 ,md25)
      if(istat2.ne.0) call cwrl(l25,i1 ,md25)
      write(ncwu,10)
   10 format(' ... is (in the form a*x+b*y+c*z=d):')
      jx = 9
      call scamb(l1m1,gg,jx)
      call scamb(l1m2,gr,jx)
      jx = 3
      call scamb(lb,x1,jx)
      call scamb(lc,x2,jx)
      call scamb(ld,x3,jx)
      call pnrc(x1,x2,x3,gg,xr)
      jx = 4
      call bmacs(le,xr,jx)
      l27ai=l27a
      istore(l27ai) = name
      n27b = n27b+1
      call cwrl(l27a,i1,md27)
      l27a = l27a - md27
      return
      end
c
code for pnrc
      subroutine pnrc (x1,x2,x3,g,pr)
c     plane perprndicular to the line passing through x1 and x2
c     and conteining point x2
c
      dimension x1(*),x2(*),x3(*),g(*)
      dimension p(4),pr(4)
      call vcmp(x1,x2,p)
      call mv(g,p,pr)
      call norm(p,pr)
      call ospr(x3,pr,b)
      pr(4) = b
      return
      end
c
code for crqm
      subroutine crqm
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),
     1 x5(6),x6(6),icomc(146)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      dimension eval(3),eve(3,3),ever(3,3)
      dimension ainer(3,3),vv(3),vr(3)
      dimension xb(3),varxb(3,3)
      dimension gg(3,3),gr(3,3)
      iwgt = 0
c----  set unitary weights in list 28
      md28 = 1
      l28 = nfl
      n28 = n25
      if(n25-2) 2999,2999,1999
 1999 continue
      mnfl = l28+n28*md28+1
      li = mnfl-1
      i128=128
      li28=28
      call xsac(i128,li28,l28,li)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      if(mnfl-lfl) 350,350,999
  350 continue
      m28 = l28
      if(iwgt) 3000,3000,2000
 3000 continue
      do 400 lli=m28,m28+n28
      store(lli) = 1.0
  400 continue
      go to 4000
 2000 continue
      m25 = l25
      do 410 lli=m28,m28+n28
      wg = store(m25+5)*store(m25+5)*store(l1m1  )
     1   + store(m25+6)*store(m25+6)*store(l1m1+4)
     2   + store(m25+7)*store(m25+7)*store(l1m1+8)
      wg = sqrt(wg)
      store(lli) = 1./wg
      m25 = m25+md25
  410 continue
      iwgt = 1
 4000 continue
      write(ncwu,10)
   10 format (/,' the l.s. line through the atom(s):')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      j9=9
      call scamb(l1m1,ggg,j9)
      call scamb(l1m2,ggr,j9)
      call m1m3 (ggg,gg)
      call m1m3 (ggr,gr)
c---- set normal equations matrix for the best plane
      call xneqp  (ggg,l25,n25,md25,m28,ainer,xb,idev,varxb)
      if(istat2) 1000,1000,1010
 1010 continue
      write(ncwu,1020) ((ainer(i,j),j=1,3),i=1,3)
 1020 format(10x,
     1 5x,'normal equat. matrix'         ,/
     2,3(10x,3f10.5,/))
 1000 continue
c---- sherch for the eigenvalues and eigenvectors
      call eignv3(gg,gr,ainer,eval,eve,ever)
      do 100 i=1,3
      vv(1) = eve(i,1)
      vv(2) = eve(i,2)
      vv(3) = eve(i,3)
      call mv(ggg,vv,vr)
      ever(i,1)= vr(1)
      ever(i,2)= vr(2)
      ever(i,3)= vr(3)
  100 continue
      if(istat2) 1090,1090,1060
 1060 continue
      write(ncwu,1070) (i,eval(i),(eve(i,j),j=1,3)
     1,                (ever(i,j),j=1,3),i=1,3)
 1070 format (/
     1,5x,'eigenvalue'
     2,5x,'real eigenvectors'
     3,5x,'dual eigenvectors'
     5,/
     4,5x,i5,2x,7f9.4)
      cin32=eval(3)/eval(2)
      cin31=eval(3)/eval(1)
      cin21=eval(2)/eval(1)
      write(ncwu,1080) cin32,cin31,cin21
 1080 format (/,5x,'indici di confidenza'
     1,/,5x,3(f8.2,2x)
     2,/)
 1090 continue
c     do 500 ind=1,3
      ind = 3
      write(ncwu,20)
   20 format(/,
     15x,' unit vector components of the best line'
     2,/,5x
     3,'  (in the form x(i)=xg(i)+u(i)*tau )'
     4,/)
      write(ncwu,80) (xb(k),k=1,3),(eve(ind,k),k=1,3)
   80 format (5x,'(g) =  ',3f10.5
     1,/,5x,'unit =   ',3f10.5
     2,/)
c---- calculate distances from the best line
      do 200 i=1,n25
      lb=m25
      lc=m25+1
      ld=m25+2
      lf = m25+5
      li=lb
      j3=3
      call scamb (ld,x1,j3)
      call ospr (vr,x1,dfp)
      call vmv (ggg,x1,x1,xx)
      xx1 = dfp*dfp
      dfl = sqrt(xx-xx1)
      stdfl = 0.0
      m=istore(m25+8)
      write(ncwu,40)(istore(li),li=m,m+1),dfl,stdfl
   40 format (5x,2a4,2f10.5)
      m25=m25+md25
      m28 = m28+1
  200 continue
      go to 9999
  999 continue
      write(ncwu,60)
   60 format (/,
     15x,'*****warning store overflow       ')
      call xerr
      go to 9999
 2999 continue
      write(ncwu,70)
   70 format (5x,
     1 '***** please enter some more atom           '
     2,/)
 9999 continue
      return
      end
c
code for xneqp
      subroutine xneqp(g,m25,n25,md25,m28,tmab,bard
     1                ,ivar,gamba)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2
      common/xdata/store(800000)
c--
      dimension tmab(3,3),barr(3),bard(3),xd(3),xr(3)
      dimension g(9),gamba(3,3)
c--
      mdx=md25
      nx=n25
      twgt= 0.0
      do 130 i=1,3
      bard(i) = 0.0
      barr(i) = 0.0
      do 130 j=1,3
      tmab(i,j) = 0.0
      gamba(i,j) = 0.0
  130 continue
      m=m25
      do 100 i= 1,nx
      lj = m28-1+i
      twgt = twgt+store(lj)
      bard(1) = bard(1)+store(m+2)*store(lj)
      bard(2) = bard(2)+store(m+3)*store(lj)
      bard(3) = bard(3)+store(m+4)*store(lj)
c      write(ncwu,*) i,nx,store(m+2),store(m+3),store(m+4),store(lj),bard
      m= m+mdx
  100 continue
       bard(1)=bard(1)/twgt
       bard(2)=bard(2)/twgt
       bard(3)=bard(3)/twgt
      call mv (g,bard,barr)
      if(ivar) 110,110,120
  120 continue
      call xvarb(m25,n25,md25,m28,gamba)
  110 continue
      m=m25
      do 200 i=1,nx
      store(m+2)= store(m+2)-bard(1)
      store(m+3)= store(m+3)-bard(2)
      store(m+4)= store(m+4)-bard(3)
c     write(ncwu,*)i,nx,store(m+2),store(m+3),store(m+4),bard
      m= m+mdx
  200 continue
      m=m25
      do 400 i=1,nx
      xd(1)=store(m+2)
      xd(2)=store(m+3)
      xd(3)=store(m+4)
      call mv(g,xd,xr)
      call ospr(xr,xd,xx)
      lj=m28-1+i
      do 500 k=1,3
      do 500 l=1,3
      tmab(k,l) =tmab(k,l)+xd(k)*xr(l)*store(lj)
c     write(ncwu,*) i,k,l,tmab(k,l),xd(k),xr(l),store(lj)
  500 continue
      m= m+mdx
  400 continue
      return
      end
c
code for eignv3
      subroutine eignv3(g,gr,tm,eival,eivec,reivec)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      dimension g(3,3),gr(3,3),tm(3,3),eival(3),eivec(3,3)
      dimension reivec(3,3)
      dimension tx(3,3)
      double precision a,atrem,b,bimez,discr,p,q,r
      pi=3.14159
c     eigenvalues and eigenvectors of
c     a 3x3 matrix in the mixed-indices
c     representation
c     first index in contravariant position
c     second index in covariant position
c     referred to unitary axes
c
c     set up the  coefficients of secular equation
c     y**3+p*y**2+q*y+r=0
c     which is then reduced in the form
c
c     x**3+a*x+b=0
c     with y=x-p/3
c          a=1/3(3q-p**2)
c          b=1/27(2p**3-9p*q+27r)
c
      p=tm(1,1)+tm(2,2)+tm(3,3)
      q=tm(1,1)*tm(2,2)-tm(1,2)*tm(2,1)
     1 +tm(1,1)*tm(3,3)-tm(1,3)*tm(3,1)
     2 +tm(2,2)*tm(3,3)-tm(2,3)*tm(3,2)
      r=tm(1,1)*tm(2,2)*tm(3,3)
     1 +tm(1,2)*tm(2,3)*tm(3,1)
     2 +tm(2,1)*tm(3,2)*tm(1,3)
     3 -tm(3,1)*tm(2,2)*tm(1,3)
     4 -tm(3,2)*tm(2,3)*tm(1,1)
     5 -tm(2,1)*tm(1,2)*tm(3,3)
      p=-p
      r = -r
      a=(3.*q-p**2)/3.
      b=(2.*p**3-9.*p*q+27.*r)/27.
      bimez=b/2.
      atrem=-a**3/27.
      discr=bimez**2-atrem
c---
c     iwu = 7
c     write(ncwu,102) p,q,r,a,b,bimez,atrem,discr
      if(discr) 100,100,900
  100 continue
      csfi=-bimez/dsqrt(atrem)
      fi=acos(csfi)
      fistre=fi/3.
      csfi1=cos(fistre)
      csfi2=cos(fistre+2.*pi/3.)
      csfi3=cos(fistre+4.*pi/3.)
      a3sq=dsqrt(-a/3.)
c---
c     write(ncwu,102) p,q,r,a,b,bimez,atrem,discr
c     write(ncwu,101) csfi,fi,fistre,csfi1,csfi2,csfi3,a3sq
c 102 format (5x,d15.8)
c 101 format(5x,f15.8)
      root1=2.*csfi1*a3sq
      root2=2.*csfi2*a3sq
      root3=2.*csfi3*a3sq
      root1=root1-p/3.
      root2=root2-p/3.
      root3=root3-p/3.
c---
c     write(ncwu,101) root1,root2,root3
      eival(1)=amin1(root1,root2,root3)
      eival(3)=amax1(root1,root2,root3)
      eival(2)=root1+root2+root3-eival(1)-eival(3)
      do 200 i=1,3
      tx(1,1)=tm(1,1)-eival(i)
      tx(2,2)=tm(2,2)-eival(i)
      tx(3,3)=tm(3,3)-eival(i)
      do 210 j=1,3
      eivec(i,j)=0.0
  210 continue
      go to (201,202,203) ,i
  201 continue
      eivec(1,1)=tx(2,2)*tx(3,3)-tm(2,3)*tm(3,2)
      eivec(1,2)=tm(3,1)*tm(2,3)-tm(2,1)*tx(3,3)
      eivec(1,3)=tm(2,1)*tm(3,2)-tm(3,1)*tx(2,2)
      go to 204
  202 continue
      eivec(2,1)=tm(1,3)*tm(3,2)-tm(1,2)*tx(3,3)
      eivec(2,2)=tx(1,1)*tx(3,3)-tm(1,3)*tm(3,1)
      eivec(2,3)=tm(1,2)*tm(3,1)-tm(3,2)*tx(1,1)
      go to 204
  203 continue
      eivec(3,1)=tm(1,2)*tm(2,3)-tm(1,3)*tx(2,2)
      eivec(3,2)=tm(2,1)*tm(1,3)-tm(2,3)*tx(1,1)
      eivec(3,3)=tx(1,1)*tx(2,2)-tm(1,2)*tm(2,1)
  204 continue
      fll=0.0
      do 250 j=1,3
      do 250 k=1,3
c----- g(i,j) is not an unitary metric
      fll =  g(j,k)*eivec(i,k)*eivec(i,j)
     1    +fll
  250 continue
      fll=sqrt(fll)
c
c     contravariant components
c     of eigenvectors
c
      eivec(i,1)=eivec(i,1)/fll
      eivec(i,2)=eivec(i,2)/fll
      eivec(i,3)=eivec(i,3)/fll
  200 continue
c----
      if(istat2.lt.5) goto 260
      write(ncwu,1)
    1 format (/)
      write(ncwu,103) ((eivec(i,j),j=1,3),i=1,3)
  103 format(5x,3f10.5)
c----
c
c     covariant components
c     of eigenvectors
c
260   do 300 i=1,3
      do 310 j=1,3
      reivec(i,j) = 0.0
      do 310 k=1,3
      reivec(i,j) = reivec(i,j)+g(j,k)*eivec(i,k)
  310 continue
      flr = 0.0
      do 350 j=1,3
      do 350 k=1,3
      flr = gr(j,k)*reivec(i,j)*reivec(i,k)+flr
  350 continue
      flr = sqrt(flr)
      reivec(i,1) = reivec(i,1)/flr
      reivec(i,2) = reivec(i,2)/flr
      reivec(i,3) = reivec(i,3)/flr
  300 continue
c----
      if(istat2.lt.5) goto 999
      write(ncwu,1)
      write(ncwu,103) ((reivec(i,j),j=1,3),i=1,3)
c----
      go to 999
900   continue
c     write(ncwu,10) discr
   10 format  (10x,d15.8 )
  999 continue
      return
      end
c
code for xvarb
      subroutine xvarb(m25,n25,md25,m28,var)
      common /xdata/ store(800000)
c--
      dimension var(3,3)
c--
      nx=n25
      mdx=md25
      tw = 0.0
      do 100 i=1,3
      do 100 j=1,3
      var(i,j) = 0.0
  100 continue
      m=m25
      do 200 li=m28,m28+nx-1
      var(1,1) = var(1,1)+store(m+5)*store(m+5)*store(li)*store(li)
      var(2,2) = var(2,2)+store(m+6)*store(m+6)*store(li)*store(li)
      var(3,3) = var(3,3)+store(m+7)*store(m+7)*store(li)*store(li)
      tw = tw+store(li)
      m=m+mdx
  200 continue
      tw = tw*tw
      var(1,1) = var(1,1)/tw
      var(2,2) = var(2,2)/tw
      var(3,3) = var(3,3)/tw
      return
      end
c
code for cpm
      subroutine cpm
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      write(ncwu,1)
    1 format (/,' the coordinates of p.m. through the atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      write(ncwu,2)
  2   format(' ...is :')
      do 100 i=1 ,3
100   x1(i)=0
      m25=l25
      do 200  i=1,n25
      lb=m25+2
      do 300 j=1,3
      x1(j)=x1(j)+store(lb)
300   lb=lb+1
200   m25=m25+md25
      do 400 i=1,3
400   x1(i)=x1(i)/n25
      write(ncwu,410)(x1(i),i=1,3)
410   format(' pm  ',3f10.4,/)
      return
      end
c
code for callc
      subroutine callc
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m26=l26
      lb=m26+2
      lc=lb+md26
      ld=lc+md26
      le=ld+md26
      write(ncwu,1)
    1 format (/,' the angle between the two lines:')
      i2=2
      call xwrl(l26,i2 ,md26)
      if(istat2.ne.0) call cwrl(l26,i2 ,md26)
      i4=4
      m26=l26+i2*md26
      call xwrl(m26,i2 ,md26)
      if(istat2.ne.0) call cwrl(m26,i2 ,md26)
      jo = 3
      call scamb(lb,x1,jo)
      call scamb(lc,x2,jo)
      call scamb(ld,x3,jo)
      call scamb(le,x4,jo)
      jo =9
      call scamb(l1m1,gg,jo)
      call scamb(l1m2,gr,jo)
      call allc (x1,x2,x3,x4,gg,ang)
      write(ncwu,20)  ang
   20 format (' ... is (in degrees)  =',f7.2)
      return
      end
c
code for allc
      subroutine allc (x1,x2,x3,x4,g,gam)
c-- line-line angle
c
      dimension x1(3),x2(3),x3(3),x4(3),g(9)
      dimension v(3),vr(3),u(3),ur(3)
      rad = 57.29578
      call vcmp(x1,x2,u)
      call vcmp(x3,x4,v)
      call mv(g,u,ur)
      call mv(g,v,vr)
      call ospr(u,vr,a)
      call ospr(u,ur,b)
      call ospr(v,vr,c)
      b=sqrt(b)
      c=sqrt(c)
      csgam=a/(b*c)
      gam=acos(csgam)
      gam = gam* rad
      return
      end
c
code for carp
      subroutine carp
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),xr(6),icomc(164)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m26=l26
      lb=m26+2
      lc=lb+md26
      ld=l27+1
      write(ncwu,10)
   10 format (/,' the angle between the line:')
      i2=2
      call xwrl(l26,i2 ,md26)
      if(istat2.ne.0) call cwrl(l26,i2 ,md26)
      write(ncwu,20)
   20 format(' ...and the plane:')
      i1=1
      call cwrl(l27,i1,md27)
      jo = 3
      call scamb(lb,x1,jo)
      call scamb(lc,x2,jo)
      call scamb(ld,xr,jo)
      jo = 9
      call scamb(l1m1,gg,jo)
      call scamb(l1m2,gr,jo)
      call arpc(x1,x2,xr,gg,gr,ang)
      write(ncwu,30) ang
   30 format (' ... is (in degrees)  =',f7.2)
      return
      end
c
code for arpc
      subroutine arpc (x1,x2,pr,g,gr,teta)
c--angle between line and plane
c
      dimension x1(*),x2(*),pr(*),g(*),gr(*)
      dimension r(3),rr(3),p(3)
      rad = 57.29578
      call vcmp(x1,x2,r)
      call mv(gr,pr,p)
      call mv(g,r,rr)
      call ospr(pr,r,a)
      call ospr(pr,p,b)
      call ospr(r,rr,c)
      b=sqrt(b)
      c = sqrt(c)
      csgam=a/(b*c)
      teta=asin(csgam)
      teta = teta *rad
      return
      end
c
code for capp
      subroutine capp
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),xr1(8),xr2(8),icomc(166)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m27=l27
      lb=m27+1
      lc=lb+md27
      write (ncwu,10)
   10 format (/,
     2 ' the angle between the two planes:')
      i2=2
      call cwrl(l27,i2,md27)
      jo = 8
      call scamb(lb,xr1,jo)
      call scamb(lc,xr2,jo)
      jo = 9
      call scamb(l1m1,gg,jo)
      call scamb(l1m2,gr,jo)
      call appc (xr1,xr2,gr,ang,sa)
      write(ncwu,20)  ang,sa
   20 format (' ... is (in degrees)  =',f7.2,'(',f7.2,')')
      return
      end
c
code for angds
      subroutine angds(k,j,rd)
c-----this routine calculates the angle formed by planes or
c-----lines with e.s.d.
      double precision m1,m2,m3,m4,up,xu(3),xou(3),cst,snt,s1,s2,
     1 th,st,cp,x,sx,xo,sxo
      common/ins1/m1,m2,m3,m4
     1      /lbl1/x(3),sx(3),xo(3),sxo(3)
     2      /lbl2/cp,up,nn
     3      /inpou/in,io
      ns1=0
      st=0d0
      do 1 i=1,3
      sx(i)=cp*sx(i)
      sxo(i)=cp*sxo(i)
      xu(i)=x(i)
1     xou(i)=xo(i)
2     continue
      s1=0d0
      s2=0d0
      do 3 i=1,3
      s1=s1+xu(i)**2
3     s2=s2+xou(i)**2
      s1=dsqrt(s1)
      s2=dsqrt(s2)
      do 4 i=1,3
      xu(i)=xu(i)/s1
4     xou(i)=xou(i)/s2
      cst=0d0
      do 5 i=1,3
5     cst=cst+xu(i)*xou(i)
      if(dabs(cst).lt.1d-8)cst=0d0
      snt=dsqrt(dabs(1d0-cst**2))
      s1=datan2(snt,cst)
      if(ns1.ne.0)go to 6
      th=s1
6     ns1=ns1+1
      s2=dabs(s1-th)
      if(s2.gt.1d-7)st=st+s2**2
      if((ns1-nn-1).eq.0)go to 9
      do 7 i=1,3
      call urn
      if(m3.ge.5d7)xu(i)=x(i)+sx(i)
7     if(m3.lt.5d7)xu(i)=x(i)-sx(i)
      do 8 i=1,3
      call urn
      if(m3.ge.5d7)xou(i)=xo(i)+sxo(i)
8     if(m3.lt.5d7)xou(i)=xo(i)-sxo(i)
      go to 2
9     sa=0.0
      if(st.gt.1d-16)sa=(up*dsqrt(st))
      ang=th
      ang=ang*rd
      sa=sa*rd
      write(io,100)k,j,ang,sa
100   format(2x,i2,6x,i2,13x,f6.2,'(',f5.2,')')
      return
      end
c
code for appc
      subroutine appc(pr1,pr2,gr,ang,sa)
c--plane-plane angle
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
c
      dimension pr1(*),pr2(*),gr(*)
      dimension p1(3),p2(3),p1s(3),p2s(3)
c--from parst96
      double precision m1,m2,m3,m4,up,xu(3),xou(3),cst,snt,s1,s2,
     1 th,st,cp,sx,sxo
      dimension sx(3),sxo(3)
      common/ins1/m1,m2,m3,m4
      common/lbl2/cp,up,nn
c--end
      rd = 57.29578
      call mv(gr,pr1,p1)
      call mv(gr,pr1(5),p1s)
      call mv(gr,pr2,p2)
      call mv(gr,pr2(5),p2s)
      ns1=0
      st=0d0
      do 1 i=1,3
      sx(i)=p1s(i)
      sxo(i)=p2s(i)
      xu(i)=p1(i)
1     xou(i)=p2(i)
2     continue
c      write(*,*) 'xu,sx',xu,sx
c      write(*,*) 'xou,sxo',xou,sxo
      s1=0d0
      s2=0d0
      do 3 i=1,3
      s1=s1+xu(i)**2
3     s2=s2+xou(i)**2
      s1=dsqrt(s1)
      s2=dsqrt(s2)
c      write(*,*)'s1,s2',s1,s2
      do 4 i=1,3
      xu(i)=xu(i)/s1
4     xou(i)=xou(i)/s2
      cst=0d0
      do 5 i=1,3
5     cst=cst+xu(i)*xou(i)
      if(dabs(cst).lt.1d-8)cst=0d0
      snt=dsqrt(dabs(1d0-cst**2))
      s1=datan2(snt,cst)
      if(ns1.ne.0)go to 6
      th=s1
6     ns1=ns1+1
c      write(ncwu,*) 'th,s1,ns1,nn',th,s1,ns1,nn
      s2=dabs(s1-th)
      if(s2.gt.1d-7)st=st+s2**2
      if((ns1-nn-1).eq.0)go to 9
      do 7 i=1,3
      call urn
      if(m3.ge.5d7)xu(i)=p1(i)+sx(i)
7     if(m3.lt.5d7)xu(i)=p1(i)-sx(i)
      do 8 i=1,3
      call urn
      if(m3.ge.5d7)xou(i)=p2(i)+sxo(i)
8     if(m3.lt.5d7)xou(i)=p2(i)-sxo(i)
      go to 2
9     sa=0.0
      if(st.gt.1d-16)sa=(up*dsqrt(st))
      ang=th
      ang=ang*rd
      sa=sa*rd
c--pone a zero sa
c      sa=0.0
c--old routine
c      call ospr(pr1,p1,b)
c      call ospr(pr2,p2,c)
c      call ospr(pr1,p2,a)
c      b = sqrt(b)
c      c = sqrt(c)
c      csgam = a/(b*c)
c      gam = acos(csgam)
c      gam = gam*rad
c--end of old routine
      return
      end
c
code for cdra
      subroutine cdra
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(3),x2(3),x3(3),x4(3),icomc(170)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m26=l26
      lb=m26+2
      lc=lb+md26
      m25=l25
      write(ncwu,10)
   10 format (/,' the distances of the atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      write(ncwu,20)
   20 format(' ...from the line:')
      i2=2
      call xwrl(l26,i2 ,md26)
      if(istat2.ne.0) call cwrl(l26,i2 ,md26)
      write(ncwu,30)
   30 format(' ...are the following:')
      do 100 i=1,n25
      ld=m25+2
      jx=9
      call scamb(l1m1,gg,jx)
      call scamb(l1m2,gr,jx)
      jx=3
      call scamb(lb,x1,jx)
      call scamb(lc,x2,jx)
      call scamb(ld,x3,jx)
      call drac(x1,x2,x3,gg,dst)
      m25i =istore(m25+8)
      write(ncwu,40)(istore(m),m=m25i,m25i+1),dst
   40 format (5x,2a4,f10.4)
      m25=m25+md25
  100 continue
      return
      end
c
code for drac
      subroutine drac(x1,x2,x3,g,d)
c--calcolo distanza retta-atomo
c
      dimension x1(*),x2(*),x3(*),g(*)
      dimension r(3),rr(3),s(3),sr(3)
      call vcmp(x1,x2,r)
      call mv(g,r,rr)
      call norm(r,rr)
      call vcmp(x3,x2,s)
      call mv(g,s,sr)
      call ospr(s,sr,a)
      call ospr(r,sr,b)
      b=b*b
      d=a-b
      d=abs(d)
      d=sqrt(d)
      return
      end
c
code for cdpa
      subroutine cdpa
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m25=l25
      lb=l27+1
      write(ncwu,10)
   10 format (/,' the distances of the atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      write(ncwu,20)
   20 format(' ...from the plane:')
      i1=1
      call cwrl(l27,i1 ,md27)
      write(ncwu,30)
   30 format(' ...are the following:')
      do 100 i=1,n25
      lc=m25+2
      jx =9
      call scamb(l1m1,gg,jx)
      call scamb(l1m2,gr,jx)
      jx = 3
      i4=4
      call scamb(lb,x1,i4)
      call scamb(lc,x2,jx)
      call dpac (x1,x2,gr,dst)
      m25i =istore(m25+8)
      write(ncwu,40)(istore(m),m=m25i,m25i+1),dst
   40 format (5x,2a4,f10.4)
      m25 = m25+md25
  100 continue
      return
      end
c
code for dpac
      subroutine dpac(pr,x,gr,d)
c--plane-atom distance
c
      dimension x(*),pr(*),gr(*)
      dimension p(3)
      call mv(gr,pr,p)
      call norm(p,pr)
      call ospr(x,pr,da)
      d = da-pr(4)
      return
      end
c
code for cans
      subroutine cans(rmn,rmx)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(3),x2(3),x3(3),x4(3),
     1 s1(3),s2(3),s3(3),s4(3),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      dimension kinea(130),istar(4)
      data istar/4*4h****/
c--
      if(rmn.eq.0.0) rmn=0.3
      if(rmx.eq.0.0) rmx=1.7
      rad = 57.29578
      nfix=0
      ndev=1
      kfat1=10000
      ifat1=500
      icod= 10
      if(isave.eq.1) then
	write(nctu) icod
      else
	if(n25.gt.0) write(ncwu,1030) rmn,rmx
1030  format(/,' angles around atoms in the limits',2f10.3)
      endif
c--controllo se ho la connettivita'
      if(store(l5d+11).lt.0.5) goto 4000
      l5c=l5+n5*md5
      if(istore(l5c).le.0)goto 4000
      call contrcon(5,l5c,m5ddum)
c      write(ncwu,*)'sw05,m5ddum',m5ddum
      nco=istore(l5c)
c      write(ncwu,*)'nco',nco
      l5cx=nfl
      m5cx=l5cx
      nn=l5c+1
c--duplica la connettivita'
      nco2=0
      do i=1,nco
c      write(ncwu,*)'istore(nn)....',i,istore(nn),istore(nn+1),
c     1  istore(nn+2)
      if(istore(nn+2).lt.0) goto 4210
      istore(m5cx  )=istore(nn	)
      istore(m5cx+1)=istore(nn+1)
      istore(m5cx+2)=istore(nn+2)
      istore(m5cx+3)=istore(nn+1)
      istore(m5cx+4)=istore(nn	)
      istore(m5cx+5)=istore(nn+2)
      nco2=nco2+2
      m5cx=m5cx+2*m5ddum
4210  continue
      nn=nn+m5ddum
      enddo
      nfl=m5cx
      izero=0
      call sorty(l5cx,nco2,m5ddum,izero)
4000  continue
      l28=nfl
      m28=l28
      md28=2
      n28=0
      i3=3
      i9=9
      call scamb(l1m1,gg,i9)
      call scamb(l1m2,gr,i9)
      if(istat2.ne.0.and.n25.gt.0) call cwrl(l25,n25,md25)
      if(n25.gt.0) then
c--angles between the given atoms
      m25=l25
      do 100 i1=1,n25
      ld =m25+2
      mx=istore(m25+8)
      call scamb(ld,x1,i3)
      m28 = l28
      n28 = 0
      m25a=l25
      do 200 i2=1,n25
      if(i1.eq.i2) goto 260
      lg =m25a+2
      call scamb(lg,x2,i3)
      call vlen (gg,x1,x2,r)
      if(r-rmn) 260,240,240
  240 continue
      if(r-rmx) 250,250,260
  250 continue
      n28 = n28+1
      istore(m28  ) = m25a
      store(m28+1) = r
      m28=m28+md28
  260 continue
      m25a=m25a+md25
  200 continue
      l29=m28
      md29=2
      if(isave.ne.0) goto 275
      if(n28.le.1) goto 120
      write(ncwu,265)(istore(i),i=mx,mx+1),n28
  265 format(/,' angles around ',2a4,' (there are',i3,
     1 ' atoms in the limits)')
  275 if(n28.le.1) goto 120
c----- calculate angle
      m28= l28
      do 300 i2=1,n28
      m25a=istore(m28)
      m=istore(m25a+8)
      if(isave.ne.0) then
       if(i2.eq.1) then
c	 write(ncwu,290)(istore(i),i=m,m+1),store(m28+1)
c  290	 format(1x,2a4,'*',f8.3,' *')
	 goto 273
       end if
      end if
      lq=m25a+2
      call scamb(lq,x3,i3)
      m29=l29
      n29=0
      m28a=l28
      do 400 i4=1,i2-1
      m25b=istore(m28a)
      lg=m25b+2
      call scamb(lg,x2,i3)
      call anamp (gg,x1,x2,x3,teta)
      an = teta*rad
      std=0.0
      if(idev) 276,276,277
  277 continue
      lld=ld+3
      call scamb(lld,s1,i3)
      lgg=lg+3
      call scamb(lgg,s2,i3)
      lqq=lq+3
      call scamb(lqq,s3,i3)
      call anstd (gg,x1,x2,x3,s1,s2,s3,teta,detet)
      std = detet*rad
  276 continue
      if(isave.eq.0) goto 520
      mm=istore(m25b+8)
      write(nctu)(istore(i),i=m,m+3),(istore(i),i=mx,mx+3),
     1 (istore(i),i=mm,mm+3),an,std
      goto 540
  520 continue
      store(m29  )=an
      store(m29+1)=std
      m29=m29+md29
      n29=n29+1
  540 m28a=m28a+md28
  400 continue
      if(isave.eq.1)goto 273
      m29 =l29
9010  jf=7
      nnn=n29
      if(nnn.gt.5) nnn=5
      do 9020 i=1,130
9020  kinea(i) = ib
      do 9110 k=1,nnn
      an=store(m29  )
      std=store(m29+1)
      je=0
      jd=1
      call snum(an,std,jd,je,jf,kinea,ndev,nfix)
      m29 =m29 +md29
9110  jf=jf+10
      m=istore(m25a+8)
      write(ncwu,41)(istore(i),i=m,m+1),store(m28+1)
     1 ,(kinea(i),i=1,58)
  41  format(1x,2a4,'*',f8.3,' * '
     1 ,100a1)
      n29=n29-nnn
      if(n29.le.0) goto 273
      write(ncwu,42)
42    format(1h0)
      goto 9010
  273 continue
      m28=m28+md28
  300 continue
  120 continue
      m25=m25+md25
  100 continue
      else
c--angles from the connectivity table
      if(store(l5d+11).lt.0.5)return
      if(istore(l5c).gt.0)then
      nn=l5cx
      kl=1
1220  continue
      if(istore(nn+2).lt.0) goto 1210
      lj=istore(nn)
      isym=0
      if(lj.lt.0) isym=1
      lj=iabs(lj)
      m5=l5+(lj-1)*md5
      ld =m5+2
      mx=m5+13
      call scamb(ld,x1,i3)
      m28 = l28
      n28 = 0
1300  continue
      lja=istore(nn+1)
c      write(ncwu,*)'nco2,kl,nn,lj,lja',nco2,kl,nn,lj,lja
      m5a=l5+(lja-1)*md5
      isym1=0
      if(lja.lt.0) isym1=1
      lja=iabs(lja)
      lg =m5a+2
      call scamb(lg,x2,i3)
      call vlen (gg,x1,x2,r)
      n28 = n28+1
      istore(m28  ) = m5a
      store(m28+1) = r
      m28=m28+md28
1310  continue
      nn=nn+m5ddum
      kl=kl+1
      if(kl.gt.nco2) goto 1320
      if(istore(nn+2).lt.0) goto 1310
      ljx=istore(nn)
      if(ljx.eq.lj) goto 1300
1320  continue
      l29=m28
      md29=2
      if(n28.le.1) goto 1230
      if(isave.ne.0) goto 2275
      write(ncwu,2265)(istore(i),i=mx,mx+1),n28
 2265 format(/,' angles around ',2a4,' (there are',i3,
     1 ' atoms in the limits)')
 2275 continue
c--calculate angle
      m28= l28
      do 2300 i2=1,n28
      m5a=istore(m28)
      m=m5a+13
c      write(ncwu,*)'i2,m5a',i2,m5a
      if(isave.ne.0) then
       if(i2.eq.1) then
c	 write(ncwu,2290)(istore(i),i=m,m+1),store(m28+1)
c 2290	 format(1x,2a4,'*',f8.3,' *')
	 goto 2273
       end if
      end if
      lq=m5a+2
      call scamb(lq,x3,i3)
      m29=l29
      n29=0
      m28a=l28
      do 2400 i4=1,i2-1
      m25b=istore(m28a)
      lg=m25b+2
      call scamb(lg,x2,i3)
      call anamp (gg,x1,x2,x3,teta)
      an = teta*rad
      std=0.0
      if(idev) 2276,2276,2277
 2277 continue
      lld=m5+20
      call scamb(lld,s1,i3)
      lgg=m25b+20
      call scamb(lgg,s2,i3)
      lqq=m5a+20
      call scamb(lqq,s3,i3)
      call anstd (gg,x1,x2,x3,s1,s2,s3,teta,detet)
      std = detet*rad
 2276 continue
      if(isave.eq.0) goto 2520
      mm=m25b+13
      write(nctu)(istore(i),i=m,m+3),(istore(i),i=mx,mx+3),
     1 (istore(i),i=mm,mm+3),an,std
c      write(ncwu,1)(istore(i),i=m,m+3),(istore(i),i=mx,mx+3),
c     1 (istore(i),i=mm,mm+3),an,std
c1     format(1x,12a4,2f10.3)
      goto 2540
 2520 continue
      store(m29  )=an
      store(m29+1)=std
      m29=m29+md29
      n29=n29+1
 2540 m28a=m28a+md28
 2400 continue
      if(isave.eq.1)goto 2273
      m29 =l29
3010  jf=7
      nnn=n29
      if(nnn.gt.5 ) nnn=5
      do 3020 i=1,130
3020  kinea(i) = ib
      do 3110 k=1,nnn
      an=store(m29  )
      std=store(m29+1)
      je=0
      jd=1
      call snum(an,std,jd,je,jf,kinea,ndev,nfix)
      m29 =m29 +md29
3110  jf=jf+10
      m=m5a+13
      write(ncwu,2241)(istore(i),i=m,m+1),store(m28+1)
     1 ,(kinea(i),i=1,58)
2241  format(1x,2a4,'*',f8.3,' * '
     1 ,100a1)
      n29=n29-nnn
      if(n29.le.0) goto 2273
      write(ncwu,2242)
2242  format(1h0)
      goto 3010
 2273 continue
      m28=m28+md28
 2300 continue
      goto 1230
1210  continue
      nn=nn+m5ddum
      kl=kl+1
1230  continue
      if(kl.le.nco2) goto 1220
c1220  continue
      end if
      end if
      if(isave.eq.1) write(nctu) istar,istar,istar,icod,icod
      return
      end
c
code for anstd
      subroutine anstd(g,x1,x2,x3,var1,var2,var3
     1,                alfa,std)
c     angle amplitude standard deviation
c     in diagonal covariance matrix approximation
      dimension var1(*),var2(*),var3(*)
      dimension g(*),x1(*),x2(*),x3(*)
      dimension caa(9),cbb(9),ccc(9)
      dimension anbl(3),bnbl(3),cnbl(3)
      dimension buv(3),cuv(3)
      dimension bvc(3),cvc(3)
      rad=57.29578
      do 100 i=1,9
      caa(i)=0.0
      cbb(i)=0.0
      ccc(i)=0.0
  100 continue
      do 200 i=1,3
      j=(i-1)*3+i
      caa(j)=var1(i)*var1(i)*g(j)
      cbb(j)=var2(i)*var2(i)*g(j)
      ccc(j) =var3(i)*var3(i)*g(j)
  200 continue
      csalfa=cos(alfa)
      snalfa=sin(alfa)
      call vcmp(x2,x1,cvc)
      call vmv (g,cvc,cvc,d12)
      d12 = sqrt(d12)
      call vcmp(x1,x3,bvc)
      call vmv(g,bvc,bvc,d13)
      d13 = sqrt(d13)
      do 300 i=1,3
      j = (i-1)*3+i
      cuv(i) = cvc(i)*sqrt(g(j))/d12
      buv(i) = bvc(i)*sqrt(g(j))/d13
  300 continue
      c = d12
      b = d13
      do 400 i=1,3
      bnbl(i)=(buv(i)+cuv(i)*csalfa)/(c*snalfa)
      cnbl(i)=-(cuv(i)+buv(i)*csalfa)/(b*snalfa)
      anbl(i)=-(bnbl(i)+cnbl(i))
  400 continue
      call vmv(caa,anbl,anbl,std1)
      call vmv(cbb,bnbl,bnbl,std2)
      call vmv(ccc,cnbl,cnbl,std3)
      std=sqrt(std1+std2+std3)
      return
      end
c
code for cpqm
      subroutine cpqm(nam)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1          eval(3),eve(3,3),ever(3,3),
     2          ainer(3,3),vv(3),vr(3),
     3          caa(3,3),xb(3),varxb(3,3),
     4		gg(3,3),gr(3,3),varian(4),l28,m28,md28,n28,icomc(63)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      if(n25-3) 2999,2999,1999
 1999 continue
      write(ncwu,10)
   10 format(/,' the l.s. plane through the atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      m25=l25
      call xpqm
      ind = 1
      le=l27a+1
      do i=1,8
      store(le+i-1)=0.0
      enddo
      l27i = l27a
      istore(l27i)=nam
      vr(1) = ever(ind,1)
      vr(2) = ever(ind,2)
      vr(3) = ever(ind,3)
      call ospr(vr,xb,dd)
c--
      store(le  )=ever(ind,1)
      store(le+1)=ever(ind,2)
      store(le+2)=ever(ind,3)
      store(le+3)=dd
      if(idev) 300,300,310
  310 continue
      lm = l25
      ln = l28
      call xpqms(lm,n25,md25,ln,xb,ever,varian)
c--
      store(le+4)=varian(1)  
      store(le+5)=varian(2)
      store(le+6)=varian(3)
      store(le+7)=varian(4)
      call vardi(ggr,varxb,vr,varba)
  300 continue
      write(ncwu,20)
   20 format(' ... is',
     2' ( in the form a*x+b*y+c*z=d):')
      i1=1
      call cwrl(l27a,i1,md27)
      write(ncwu,30)
   30 format(/,' dist. from best plane and e.s.d.:')
      m25=l25
      m28 = l28
c---- calculate distances from the best plane
      do 200 i=1,n25
      lb=m25
      lc=m25+1
      ld=m25+2
      lf = m25+5
      li=lb
      i3=3
      call scamb(ld,x1,i3)
      call ospr (vr,x1,dfp)
      stdfp = 0.0
      if(idev) 210,210,220
  220 continue
      do 230 j=1,3
      do 230 k=1,3
      caa(j,k) = 0.0
  230 continue
c---- calculate the variances acros the best plane
      caa(1,1) = store(lf  )*store(lf  )
      caa(2,2) = store(lf+1)*store(lf+1)
      caa(3,3) = store(lf+2)*store(lf+2)
      call vardi(ggr,caa,vr,var)
      stdfp = varba+var
      if(stdfp.lt.0.and.stdfp.gt.-.10)stdfp=0.
      stdfp = sqrt(stdfp)
  210 continue
      m=istore(m25+8)
      write(ncwu,40)(istore(mm),mm=m,m+1),dfp,stdfp
   40 format(1x,2a4,2f10.5)
      m25=m25+md25
      m28 = m28+1
  200 continue
      l27a = l27a-md27
      n27b = n27b+1
      go to 9999
 2999 continue
      write(ncwu,70)
   70 format(/,5x,'***** please enter some more atom ',/)
 9999 continue
      return
      end
c
code for xpqm
      subroutine xpqm
c--main routine for l.s. plane calculation
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1          eval(3),eve(3,3),ever(3,3),
     2          ainer(3,3),vv(3),vr(3),
     3          caa(3,3),xb(3),varxb(3,3),
     4		gg(3,3),gr(3,3),varian(4),l28,m28,md28,n28,icomc(63)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
c--set unitary weights in list 28
      md28 = 1
      l28 = nfl
      n28 = n25
      mnfl = l28+n28*md28+1
      li = mnfl-1
      i128=128
      li28=28
      call xsac (i128,li28,l28,li)
      if(istat2.lt.2) goto 5000
      call xpas
      call xline
 5000 continue
      m28 = l28
      do 400 l=m28,m28+n28
      store(l) = 1.0
  400 continue
      i9=9
      call scamb(l1m1,ggg,i9)
      call scamb(l1m2,ggr,i9)
      call m1m3 (ggg,gg)
      call m1m3 (ggr,gr)
c---- set normal equations matrix for the best plane
      call xneqp(ggg,l25,n25,md25,m28,ainer,xb,idev,varxb)
      if(istat2) 1000,1000,1010
 1010 continue
      write(ncwu,1020) ((ainer(i,j),j=1,3),i=1,3)
 1020 format(15x,'normal equat. matrix          ',/
     2,3(10x,3f10.5,/))
 1000 continue
c--search for the eigenvalues and eigenvectors
      call eign3(gg,gr,ainer,eval,eve,ever)
      do 100 i=1,3
      vv(1) = eve(i,1)
      vv(2) = eve(i,2)
      vv(3) = eve(i,3)
      call mv(ggg,vv,vr)
      ever(i,1)= vr(1)
      ever(i,2)= vr(2)
      ever(i,3)= vr(3)
  100 continue
      if(istat2) 1090,1090,1060
 1060 continue
      write(ncwu,1070) (i,eval(i),(eve(i,j),j=1,3)
     1,                (ever(i,j),j=1,3),i=1,3)
1070  format(/,'eigenvalue'
     2,5x,'real eigenvectors'
     3,5x,'dual eigenvectors',/
     4,5x,i5,2x,7f9.4)
      cin32=eval(3)/eval(2)
      cin31=eval(3)/eval(1)
      cin21=eval(2)/eval(1)
      write(ncwu,1080) cin32,cin31,cin21
 1080 format (/,5x,'indici di confidenza '
     1,/,5x,3(f8.2,2x),/)
 1090 continue
      return
      end
c
code for vardi
      subroutine vardi (gr,var,xr,vardir)
      dimension gr(*),var(3,3),xr(*),gamma(9)
c---- variance-covariance matrix is supposed to be
c---- in contravariant representation
c---- and referred to crystal axes
      call vmv(gr,xr,xr,x2)
      call m3m1(var,gamma)
      call vmv(gamma,xr,xr,vardir)
      vardir = vardir/x2
      return
      end
c
code for xpqms
      subroutine xpqms (m25,n25,md25,m28,bard,reivec,varmd)
      dimension bard(*)
      dimension reivec(3,3),varmd(*)
      dimension rm1(3),rm2(3),rm3(3)
      dimension dy1(9),dy2(9),dy3(9),dy4(9),gamm(9)
      dimension gamp(9),caa(9),fnabm(9),fnabd(3)
      dimension xd(3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common /xdata/store(800000)
c--
      xz2 = 0.0
      yz2 = 0.0
      nx = n25
      mdx = md25
      do 100 i=1,3
      rm1(i) = reivec(1,i)
      rm2(i) = reivec(2,i)
      rm3(i) = reivec(3,i)
  100 continue
      m = m25
c--	write(ncwu,*)'m25,n25,md25',m25,n25,md25
      do 150 i=1,nx
      xd(1) = store(m+2)
      xd(2) = store(m+3)
      xd(3) = store(m+4)
      call ospr(rm1,xd,xt)
      call ospr(rm2,xd,yt)
      call ospr(rm3,xd,zt)
      xz2 = xz2+xt*xt-zt*zt
      yz2 = yz2+yt*yt-zt*zt
      m = m+mdx
  150 continue
      xz2 = xz2/nx
      yz2 = yz2/nx
      call dya(rm1,rm1,dy1)
      call dya(rm3,rm1,dy2)
      call dya(rm2,rm2,dy3)
       call dya(rm3,rm2,dy4)
      do 200 i=1,9
      dy1(i) = dy1(i)/xz2
      dy2(i) = dy2(i)/xz2
      dy3(i) = dy3(i)/yz2
      dy4(i) = dy4(i)/yz2
  200 continue
      twgt = 0.0
      do 210 i=m28,m28+nx-1
      twgt = store(i)+twgt
  210 continue
      call ospr(bard,rm1,barx)
      call ospr(bard,rm2,bary)
      do 220 i=1,9
      gamm(i) = 0.0
  220 continue
      dvar = 0.0
      m = m25
      do 300 i=m28,m28+nx-1
c---- calculation of nabla(m)
      xd(1) = store(m+2)
      xd(2) = store(m+3)
      xd(3) = store(m+4)
      call ospr(rm1,xd,xt)
      call ospr(rm2,xd,yt)
      call ospr(rm3,xd,zt)
      do 400 k=1,9
      fnabm(k) = -zt*dy1(k)-xt*dy2(k)
     1           -zt*dy3(k)-yt*dy4(k)
      fnabm(k) = fnabm(k)*store(i)/twgt
  400 continue
c----
c---- calculation of variance-covariance
c---- matrix caa(9)  of atomic positions
c----
      do 410 k=1,9
      caa(k) = 0.0
  410 continue
      do 420 k=1,3
      j = (k-1)*3+k
      caa(j) = store(m+4+k)*store(m+4+k)
  420 continue
c---- calculation of gamma(m) dyadic
      call mmm(fnabm,caa,fnabm,gamp)
      do 430 k=1,9
      gamm(k) = gamm(k)+gamp(k)
  430 continue
c---- calculation of nabla(d)
      do 450 k=1,3
      fnabd(k) = rm3(k)
     1         -barx*(zt*rm1(k)+xt*rm3(k))/xz2
     2         -bary*(zt*rm2(k)+yt*rm3(k))/yz2
      fnabd(k) = fnabd(k)*store(i)/twgt
  450 continue
c---- calculation of variance for -d-
      call vmv(caa,fnabd,fnabd,dvarp)
      dvar = dvar+dvarp
      m = m+mdx
  300 continue
      if(dvar.gt.0)go to 302
c	write(ncwu,301)dvar
c301   format(1x,' dvar = ',f10.3)
      dvar=0.0
302   continue
      dvar = sqrt(dvar)
      do 500 i=1,3
      j = (i-1)*3+i
      if(gamm(j).gt.0)go to 502
c      write(ncwu,501)j,gamm(j)
c501   format(1x,'gamm(',i2,' = ',f10.3)
      gamm(j)=0.0
502   continue
      varmd(i) = sqrt(gamm(j))
  500 continue
      varmd(4) = dvar
      return
      end
c
code for dya
      subroutine dya(v1,v2,dy)
c---- calculation of a dyadic as product
c---- of two vectors
c----     dy(i,j) = v1(i).v2(j)
c----- the dyadic is in unidim. represent.
      dimension dy(*),v1(*),v2(*)
      do 100 i=1,3
      do 100 j=1,3
      ij = (i-1)*3+j
      dy(ij) = v1(i)*v2(j)
  100 continue
      return
      end
c
code for ctor
      subroutine ctor
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
      common/workc/gg(9),gr(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
c
      sdtau = 1.
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      m25=l25
      j=n25-3
      write (ncwu,10)
   10 format(/,'  torsion angle(s) along the chain of atoms:')
      call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      write(ncwu,20)
   20 format(' ... are the following(s)')
      i4=4
      do 100 i=1,j
      call xwrl(m25,i4 ,md25)
      if(istat2.ne.0) call cwrl(m25,i4 ,md25)
      lb=m25+2
      lc=lb+md25
      ld=lc+md25
      le=ld+md25
      sdtau = 1.0
      jx = 9
      call scamb (l1m1,gg,jx)
      call scamb (l1m2,gr,jx)
      jx = 6
      call scamb (lb,x1,jx)
      call scamb (lc,x2,jx)
      call scamb (ld,x3,jx)
      call scamb (le,x4,jx)
      call torcs (x1,x2,x3,x4,gg,gr,tau,sdtau)
      write(ncwu,30) tau
   30 format(' angle (in degrees)=',f7.2)
      if(idev) 201,201,301
  301 continue
      write(ncwu,40) sdtau
   40 format(' sigma(angle)      =',f7.2)
  201 continue
      m25=m25+md25
  100 continue
      return
      end
c
code for torcs
      subroutine torcs(x1,x2,x3,x4,g,gr,tau,sdtau)
c---- torsion angle calculation
c---- and standard deviation
c----
      dimension x1(6),x2(6),x3(6),x4(6)
      dimension g(*),gr(*)
      dimension a(3),b(3),c(3),d(3),f(3),hr(3)
      dimension dr(3),fr(3)
      dimension u(3),v(3),p1(3),p2(3),pr1(3),pr2(3)
      dimension c11(9),c22(9),c33(9),c44(9)
      dimension gamqa(9),gamqb(9),gamqq(9)
      dimension  ut1(9), ut2(9), ut3(9)
      rad = 57.29578
      call vcmp (x3,x4,a)
      call vcmp (x2,x3,b)
      call vcmp (x1,x2,c)
      call vpr (g,a,b,dr)
      call vpr (g,b,c,fr)
      call mv (gr,fr,f)
      call mv (gr,dr,d)
      call ospr (d,fr,aa)
      call ospr (d,dr,qa)
      call ospr (f,fr,qb)
      if (qa.lt.0.000.and.qa.gt.-0.001) qa = 0.0000
      if (qb.lt.0.000.and.qb.gt.-0.001) qb = 0.0000
      qa = sqrt(qa)
      qb = sqrt(qb)
      cstau = aa/(qa*qb)
      call vpr (g,c,a,hr)
      call ospr (hr,b,s)
      tau = acos (cstau)
c---- controlla che -s- non sia zero
       if(s) 100,200,100
  200 continue
      s = 1.0
  100 continue
      tau = sign(tau,s)
      tau = tau*rad
      if(sdtau) 1000,1000,300
  300 continue
      do 310 i=1,9
      c11(i) = 0.0
      c22(i) = 0.0
      c33(i) = 0.0
      c44(i) = 0.0
      gamqa(i) = 0.0
      gamqb(i) = 0.0
      gamqq(i) = 0.0
      ut1(i) = 0.0
      ut2(i) = 0.0
      ut3(i) = 0.0
  310 continue
c---  variance-covariance matrix  in contrav. repres.
      do 320 i=1,3
      j = (i-1)*3+i
      ii = i+3
      c11(j) = x1(ii)*x1(ii)
      c22(j) = x2(ii)*x2(ii)
      c33(j) = x3(ii)*x3(ii)
      c44(j) = x4(ii)*x4(ii)
  320 continue
      do 330 i=1,3
      u(i) = -a(i)-b(i)
      v(i) = -b(i)-c(i)
  330 continue
c---  calculation of gamma(qa) dyadic
      call vudy(g,b,ut1)
      call mmm( ut1,c44, ut1, ut2)
      do 401 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  401 continue
      call vudy(g,u,ut1)
      call mmm( ut1,c33, ut1, ut2)
      do 402 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  402 continue
      call vudy(g,a,ut1)
      call mmm( ut1,c22, ut1, ut2)
      do 403 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  403 continue
c---  calculation of gamma(qb) dyadic
      call vudy(g,c,ut1)
      call mmm( ut1,c33, ut1, ut2)
      do 411 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  411 continue
      call vudy(g,v,ut1)
      call mmm( ut1,c22, ut1, ut2)
      do 412 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  412 continue
      call vudy(g,b,ut1)
      call mmm( ut1,c11, ut1, ut2)
      do 413 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  413 continue
c---  calculation of gamma(qa,qb) dyadic
      call vudy(g,u,ut1)
      call vudy(g,c,ut2)
      call mmm( ut1,c33, ut2, ut3)
      do 421 i=1,9
      gamqq(i) = - ut3(i)+gamqq(i)
  421 continue
      call vudy(g,a,ut1)
      call vudy(g,v,ut2)
      call mmm( ut1,c22, ut2, ut3)
      do 422 i=1,9
      gamqq(i) = - ut3(i)+gamqq(i)
  422 continue
c---  p1 and p2  components
      call vpr(g,d,b,pr1)
      call mv(gr,pr1,p1)
      call norm (pr1,p1)
      call vpr(g,b,f,pr2)
      call mv(gr,pr2,p2)
      call norm(pr2,p2)
c---  sigma(tau) calculation
      call vmv(gamqa,p1,p1,sig21)
      sig21 = sig21/(qa*qa)
      call vmv(gamqb,p2,p2,sig22)
      sig22 = sig22/(qb*qb)
      call vmv(gamqq,p1,p2,sig23)
      sig23 = sig23*2./(qa*qb)
      sdtau = sig21+sig22+sig23
      sdtau = sqrt(sdtau)
      sdtau = sdtau*rad
 1000 continue
      return
      end
c
cdoe for vudy
      subroutine vudy(g,v,udy)
c---- vector cros unit dyadic
c----  dyadic is in contravariant representation
c----
      dimension  v(*),udy(*)
      dimension g(*)
      call dt3 (g,vol)
      vol = sqrt(vol)
      do 10 i=1,9
      udy(i) =0.0
   10 continue
      udy(2) = -v(3)
      udy(3) =  v(2)
      udy(4) =  v(3)
      udy(6) = -v(1)
      udy(7) = -v(2)
      udy(8) =  v(1)
      do 20 i=1,9
      udy(i) = udy(i)*vol
   20 continue
      return
      end
c
code for vstd
      subroutine vstd (g,x1,x2,var1,var2,std)
c-----vector length standard deviation
c-----in diagonal covariance matrix approximation
      dimension x1(*),x2(*),var1(*),var2(*),g(*)
      dimension caa(9),cbb(9),gam(9),v(3),vr(3)
      do 100 i=1,9
      caa(i) = 0.0
      cbb(i) = 0.0
  100 continue
      do 200 i=1,3
      j = (i-1)*3+i
      caa(j) = var1(i)*var1(i)
      cbb(j) = var2(i)*var2(i)
      caa(j) = caa(j)*g(j)
      cbb(j) = cbb(j)*g(j)
  200 continue
      do 300 i=1,9
      gam(i) = caa(i)+cbb(i)
  300 continue
      call vcmp(x2,x1,v)
      call mv(g,v,vr)
      call norm(v,vr)
      v(1) = v(1)*sqrt(g(1))
      v(2) = v(2)*sqrt(g(5))
      v(3) = v(3)*sqrt(g(9))
      call vmv(gam,v,v,divar)
      std = sqrt(divar)
      return
      end
c
code for cdis
      subroutine cdis (rmn,rmx)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xnclu/ncmu,nctu,ncau,ncsu,nclg,nccf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c
      common/lst25/l25,m25,md25,n25
      common/workc/gg(9),gr(9),x1(3),x2(3),x3(3),x4(3),
     1 s1(3),s2(3),s3(3),s4(3),icomc(158)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      dimension kinea(130),istar(4)
      data istar/4*4h****/
c--
      if(rmn.eq.0.0) rmn=0.3
      if(rmx.eq.0.0) rmx=1.7
      ndev=1
      nfix=0
      kfat1=10000
      ifat1=500
      icod=-10
      if(isave.eq.1) then
	write(nctu) icod
      else
	if(n25.gt.0) write(ncwu,1030) rmn,rmx
1030  format(/,' distances in the limits',2f10.3,/)
      endif
      l28=nfl
      m28=l28
      md28=2
      n28=0
      i3=3
      i9=9
      call scamb(l1m1,gg,i9)
      call scamb(l1m2,gr,i9)
c      write(ncwu,*) 'n25',n25
      if(istat2.ne.0.and.n25.gt.0) call cwrl(l25,n25,md25)
      if(n25.gt.0) then
c--distances between the given atoms
      m25=l25
      do 100 i1=1,n25-1
      ld =m25+2
      call scamb(ld,x1,i3)
      m25a=m25+md25
      do 200 i2=i1+1,n25
      lg =m25a+2
      call scamb(lg,x2,i3)
c      write(ncwu,*)'x1',x1
c      write(ncwu,*)'x2',x2
      call vlen (gg,x1,x2,r)
c      write(ncwu,*)'r',r
      if(r-rmn) 232,240,240
  240 continue
      if(r-rmx) 250,250,232
  250 continue
      cova=0.0
      if(idev) 276,276,275
275   continue
      ldd=ld+3
      lgg=lg+3
      call scamb(ldd,s1,i3)
      call scamb(lgg,s2,i3)
c      write(ncwu,*)'s1',s1
c      write(ncwu,*)'s2',s2
      call vstd (gg,x1,x2,s1,s2,cova)
c      write(ncwu,*)'cova',cova
  276 continue
      irr=kintk(r*1000.0)
      icov=kintk(cova*1000.0)
      istore(m28  )=i2*ifat1+i1
      istore(m28+1)=irr*kfat1+icov
      m28=m28+md28
      n28=n28+1
      if(isave.eq.0) goto 232
      mx=istore(m25 +8)
      m =istore(m25a+8)
      write(nctu)(istore(i),i=mx,mx+3),(istore(i),i=m,m+3),
     1 (istore(i),i=m,m+3),r,cova
  232 continue
      m25a=m25a+md25
  200 continue
      m25=m25+md25
  100 continue
      else
c--distances from the connectivity table
c      write(ncwu,*) 'store(l5d+11)  ',store(l5d+11)
      if(store(l5d+11).lt.0.5)return
      l5c=l5+n5*md5
      call contrcon(5,l5c,m5ddum)
c      write(ncwu,*)'sw05,m5ddum',m5ddum
c      write(ncwu,*) 'store(l5c)  ',store(l5c)
      if(istore(l5c).gt.0)then
      nco=istore(l5c)
      nn=l5c+1
      do 1220 kl=1,nco
      if(istore(nn+2).lt.0) goto 1210
      lj=istore(nn)
      m5=l5+(lj-1)*md5
      isym=0
      if(lj.lt.0)then
       isym=1
       m5=l5+(-lj-1)*md5
      endif
      m5h=m5+13
      lja=istore(nn+1)
      m5a=l5+(lja-1)*md5
      isym1=0
      if(lja.lt.0)then
       isym1=1
       m5a=l5+(-lja-1)*md5
      endif
      m5ha=m5a+13
      ld =m5+2
      call scamb(ld,x1,i3)
      lg =m5a+2
      call scamb(lg,x2,i3)
      call vlen (gg,x1,x2,r)
      cova=0.0
      if(idev) 1276,1276,1275
1275  continue
      ldd=m5+20
      lgg=m5a+20
      call scamb(ldd,s1,i3)
      call scamb(lgg,s2,i3)
      call vstd (gg,x1,x2,s1,s2,cova)
1276  continue
      irr=kintk(r*1000.0)
      icov=kintk(cova*1000.0)
      istore(m28  )=lja*ifat1+lj
      istore(m28+1)=irr*kfat1+icov
      m28=m28+md28
      n28=n28+1
      if(isave.eq.0) goto 1232
      write(nctu)(istore(i),i=m5h,m5h+3),(istore(i),i=m5ha,m5ha+3),
     1 (istore(i),i=m5ha,m5ha+3),r,cova
c      write(ncwu,1)(istore(i),i=m5h,m5h+3),(istore(i),i=m5ha,m5ha+3),
c     1 (istore(i),i=m5ha,m5ha+3),r,cova
c1     format(12a4,2f10.3)
1232  continue
1210  continue
      nn=nn+m5ddum
1220  continue
      end if
      end if
      if(isave.eq.0) goto 9000
      write(nctu) istar,istar,istar,icod,icod
      return
9000  continue
      nstep=8
      lx=l25
      mdx=md25
      if(n25.eq.0) then
       nstep=13
       lx=l5
       mdx=md5
      endif
      m28=l28
      nx=0
      do 9040 i=1,n28
      if(istore(m28).le.0) goto 9062
      call iad28(m28 ,lx,mdx,nstep,kfat1,ifat1,r,cova,m,mx)
      do 9045 k=1,8
9045  itemp(k)=ib
      call scar(istore(m),itemp,4)
      do 9050 k=1,8
      k1=k
      if(itemp(k).eq.ib) goto 9060
9050  continue
9060  nx=max0(nx,k1)
      do 9046 k=1,8
9046  itemp(k)=ib
      call scar(istore(mx),itemp,4)
      do 9051 k=1,8
      k1=k
      if(itemp(k).eq.ib) goto 9061
9051  continue
9061  nx=max0(nx,k1)
9062  continue
      m28=m28+md28
9040  continue
      mmm=nx+2+nx+6+3+4
      nnn=79/mmm
      n28a=n28/nnn
      if(n28a*nnn.eq.n28) goto 9010
      n28a=n28a+1
      i=n28a*nnn-n28
      do 9015 j=1,i
      istore(m28)=-1
9015  m28=m28+md28
9010  m28=l28
      md28a=n28a*md28
      m28=l28
      do 9100 j=1,n28a
      do 9020 i=1,130
9020  kinea(i) = ib
      m28a=m28
      k1=3
      do 9110 k=1,nnn
      if(istore(m28a).le.0) goto 9105
      call iad28(m28a,lx,mdx,nstep,kfat1,ifat1,r,cova,m,mx)
      call slinea(m ,nx,k1,kinea)
      kinea(k1+nx)=inus
      j1=k1+nx+2
      call slinea(mx,nx,j1,kinea)
      je=0
      jf=j1+nx+6
      jd=3
      call snum(r,cova,jd,je,jf,kinea,ndev,nfix)
9105  m28a=m28a+md28a
9110  k1=k1+2*nx+15
      write(ncwu,41)  (kinea(i),i=1,79)
   41 format (1x,79a1)
      m28=m28+md28
9100  continue
      return
      end
c
code for iad28
      subroutine iad28(m28a,l25,md25,nstep,kfat1,ifat1,r,cova,m,mx)
c--extract values from list 28
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
c--
c     write(ncwu,*) m28a,l25,md25,kfat1,ifat1
      i2=istore(m28a)/ifat1
      i1=istore(m28a)-i2*ifat1
      irr=istore(m28a+1)/kfat1
      icov=istore(m28a+1)-irr*kfat1
      r=float(irr)/1000.
      cova=float(icov)/1000.
      m25 =l25+(i1-1)*md25
      m25a=l25+(i2-1)*md25
      m =istore(m25 +nstep)
      mx=istore(m25a+nstep)
c     write(ncwu,*) i2,i1,irr,icov,m25,m25a,m,mx
      return
      end
c
code for cprz
      subroutine cprz(iln)
c--projection of the atoms on the lpt device
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,dummy
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jcif,isave,idev
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst25/l25,m25,md25,n25
      common/workc/ggg(9),ggr(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1          eval(3),eve(3,3),ever(3,3),
     2          ainer(3,3),vv(3),vr(3),
     3          caa(3,3),xb(3),varxb(3,3),
     4		gg(3,3),gr(3,3),varian(4),l28,m28,md28,n28,icomc(63)
      common/xdata/store(800000)
      dimension   istore(800000)
      equivalence(store,istore)
      integer*4 ifmt(120),iblank,iend
      dimension  xmax(3), xmin(3)
      data ifmt(1)/4h(1h+/,ifmt(2)/4h,1h*/,ifmt(3)/1h,/
      data iblank/3h1x,/,iend/3hi3)/
c--
      if(istat2-1) 5000,5000,5100
 5100 continue
      call xpas
      call xline
 5000 continue
      if(n25-3) 2999,2999,1999
 1999 continue
      if(iln.eq.0) write(ncwu,10)
   10 format(' plot projection onto l.s. plane:')
      m25=l25
      if(iln.eq.0) call xwrl(l25,n25,md25)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
      call xpqm
      do 1020 i=1,3
      xmax(i)=-100000.
1020  xmin(i)= 100000.
      m25=l25
      do 100 k=1,n25
      lc=m25+2
      jx = 3
      call scamb(lc,x2,jx)
      do 1000 i=1,3
      x3(i)=0.0
      do 1010 j=1,3
      x3(i)=x3(i)+x2(j)*ever(i,j)
1010  continue
      xmax(i)=amax1(xmax(i),x3(i))
      xmin(i)=amin1(xmin(i),x3(i))
1000  continue
      m25i = istore(m25+8)
      if(istat2.ne.0)
     1write(ncwu,20)(istore(m),m=m25i,m25i+1),(x3(i),i=1,3)
   20 format (1x,2a4,3f10.4)
      call bmacs(lc,x3,jx)
      store(m25+1)=k
      m25 = m25+md25
  100 continue
      if(istat2.ne.0) call cwrl(l25,n25,md25)
c--number of lines per inch on lineprinter
      aln=6
      n1 = 3
      n2 = 2
      if (115.0/(xmax(2)-xmin(2)) .ge. 2.0/0.254) go to 1190
      n1 = 2
      n2 = 3
c--calculate scale factor to fill page or give 2.5 cms/a
 1190 amax = amax1(xmax(n2)-xmin(n2), xmax(n1)-xmin(n1))
      scale = amin1(115.0/amax, 2.5/0.254)
      scl = 0.254 * scale
c--sort peaks in order of plotting
 1200 jump=-(n1+2)
      call sortz(l25,n25,md25,jump)
      if(istat2.ne.0) call cwrl(l25,n25,md25)
c--output heading and plot peaks
      write(ncwu,1260)scl
 1260 format(' scale :',f6.2,' cms/a',
     1//,1x,130(1h*))
      do 1401 j=1,3
 1401 write(ncwu,1380)
 1380 format(2h *,128x,1h*)
      ix=0
      offset = 0.5 * (115.0 - (xmax(n2) - xmin(n2)) * scale) + 1.5
      m25=l25
      do 1460 i=1,n25
      lc=m25+2
      call scamb(lc,x2,jx)
      ixrel = 0.1 * aln * scale * (xmax(n1)-x2(n1)) - float(ix) + 0.5
      if(ixrel.le.0)go to 1420
      do 1400 j=1,ixrel
 1400 write(ncwu,1380)
 1420 ix=ix+ixrel
      iy=scale*(x2(n2)-xmin(n2))+offset
      do 1440 j=1,iy
      ifmt(j+3)=iblank
 1440 continue
      ifmt(iy+4)=iend
      k=store(m25+1)
      write(ncwu,ifmt)k
      write(ncwu,1385)
 1385 format(2h+*,128x,1h*)
      m25=m25+md25
 1460 continue
      do 1402 j=1,2
 1402 write(ncwu,1380)
      write(ncwu,1386)
 1386 format(1x,130(1h*),/)
      goto 9999
 2999 continue
      write(ncwu,70)
   70 format(/,5x,'***** please enter some more atom ',/)
 9999 continue
      return
      end
c
code for xwrl
      subroutine xwrl(lll,nn,mmd)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common /xdata/ store(800000)
      dimension     istore(800000)
      equivalence(store,istore)
      dimension linea(130)
c--
      mn = lll
      mdpr=mmd
      if(mmd.eq.5)return
      do 1000 i=1,130
1000  linea(i)=ib
      il=1
      do 100 ii=1,nn
      m=istore(mn+8)
      do 1010 i=1,8
1010  itemp(i)=ib
      call scar(istore(m),itemp,4)
      do 1020 i=1,8
      i1=i
      if(itemp(i).ne.ib) goto 1020
      if(i1.gt.1) then
                  i1=i-1
                  goto 1030
                  else
                  itemp(1)=ih
                  goto 1030
                  endif
1020  continue
1030  continue
      do 1040 i=1,i1
      linea(il)=itemp(i)
1040  il=il+1
      if(ii.eq.nn) il=61
      if(il.gt.60) then
                   write(ncwu,1050) (linea(i),i=1,il)
1050               format(1x,70a1)
                   do 1060 i=1,130
1060               linea(i)=ib
                   il=1
                   goto 1070
                   else
                   linea(il)= inus
                   il=il+1
                   endif
1070  continue
      mn=mn+mmd
  100 continue
      return
      end
c
code for urn
      subroutine urn
c-----this routine calculates 8-digit pseudo-random numbers
c-----following c.g.swain & m.s.swain, j.chem.inf.comput.sci.
c-----(1980),20, p. 56
      double precision m1,m2,m3,m4
      common/ins1/m1,m2,m3,m4
      m4=m1+m2+m3
      if(m2.lt.5d7)m4=m4+1357d0
      if(m4.ge.1d8)m4=m4-1d8
      if(m4.ge.1d8)m4=m4-1d8
      m1=m2
      m2=m3
      m3=m4
      return
      end
